package com.example.dams;

import android.os.Parcel;
import android.os.Parcelable;

import java.util.List;

public class Conceito extends Capitulo implements Parcelable {
    private int posModulo, posCapitulo;
    private String texto;
    private String formula;
    private List<String> pergunta1, pergunta2, pergunta3, pergunta4, pergunta5;

    public Conceito(String titulo) {
        super(titulo);
    }

    public Conceito(int posModulo, int posCapitulo, String titulo, String texto, String formula, List<String> pergunta1, List<String> pergunta2, List<String> pergunta3, List<String> pergunta4, List<String> pergunta5) {
        super(titulo);
        this.posModulo = posModulo;
        this.posCapitulo = posCapitulo;
        this.texto = texto;
        this.formula = formula;
        this.pergunta1 = pergunta1;
        this.pergunta2 = pergunta2;
        this.pergunta3 = pergunta3;
        this.pergunta4 = pergunta4;
        this.pergunta5 = pergunta5;
    }

    protected Conceito(Parcel in) {
        titulo = in.readString();
        posModulo = in.readInt();
        posCapitulo = in.readInt();
        texto = in.readString();
        formula = in.readString();
        pergunta1 = in.createStringArrayList();
        pergunta2 = in.createStringArrayList();
        pergunta3 = in.createStringArrayList();
        pergunta4 = in.createStringArrayList();
        pergunta5 = in.createStringArrayList();
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(titulo);
        dest.writeInt(posModulo);
        dest.writeInt(posCapitulo);
        dest.writeString(texto);
        dest.writeString(formula);
        dest.writeStringList(pergunta1);
        dest.writeStringList(pergunta2);
        dest.writeStringList(pergunta3);
        dest.writeStringList(pergunta4);
        dest.writeStringList(pergunta5);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<Conceito> CREATOR = new Creator<Conceito>() {
        @Override
        public Conceito createFromParcel(Parcel in) {
            return new Conceito(in);
        }

        @Override
        public Conceito[] newArray(int size) {
            return new Conceito[size];
        }
    };

    public int getPosModulo() {
        return posModulo;
    }

    public void setPosModulo(int posModulo) {
        this.posModulo = posModulo;
    }

    public int getPosCapitulo() {
        return posCapitulo;
    }

    public void setPosCapitulo(int posCapitulo) {
        this.posCapitulo = posCapitulo;
    }

    public String getTexto() {
        return texto;
    }

    public void setTexto(String texto) {
        this.texto = texto;
    }

    public String getFormula() {
        return formula;
    }

    public void setFormula(String formula) {
        this.formula = formula;
    }

    public List<String> getPergunta1() {
        return pergunta1;
    }

    public void setPergunta1(List<String> pergunta1) {
        this.pergunta1 = pergunta1;
    }

    public List<String> getPergunta2() {
        return pergunta2;
    }

    public void setPergunta2(List<String> pergunta2) {
        this.pergunta2 = pergunta2;
    }

    public List<String> getPergunta3() {
        return pergunta3;
    }

    public void setPergunta3(List<String> pergunta3) {
        this.pergunta3 = pergunta3;
    }

    public List<String> getPergunta4() {
        return pergunta4;
    }

    public void setPergunta4(List<String> pergunta4) {
        this.pergunta4 = pergunta4;
    }

    public List<String> getPergunta5() {
        return pergunta5;
    }

    public void setPergunta5(List<String> pergunta5) {
        this.pergunta5 = pergunta5;
    }

}
