package com.example.dams;

import android.content.Intent;
import android.os.Bundle;
import android.text.Html;
import android.util.Base64;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;
import androidx.appcompat.app.AppCompatActivity;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Locale;

public class ConceitosActivity extends AppCompatActivity {

    private WebView conceitosWebView;
    private TextView tituloTextView, enunciadoTextView;
    //private MathView formulaMathView;
    private RadioGroup perguntaRadioGroup;
    private RadioButton op1RadioButton, op2RadioButton, op3RadioButton, op4RadioButton, op5RadioButton;
    private ProgressBar perguntasProgressBar;
    private Button responderButton, concluirButton;
    private Conceito conceito;
    private List<List<String>> perguntas;
    private int qtdePerguntas = 0, acertos = 0;
    private String resposta, selecionada, feedback;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_conceitos);
        tituloTextView = findViewById(R.id.conceitosTituloTextView);
        conceitosWebView = findViewById(R.id.conceitosWebView);
        //formulaMathView = findViewById(R.id.conceitosMathView);
        enunciadoTextView = findViewById(R.id.conceitosPerguntaTextView);
        perguntaRadioGroup = findViewById(R.id.conceitosPerguntaRadioGroup);
        op1RadioButton = findViewById(R.id.conceitosOp1RadioButton);
        op2RadioButton = findViewById(R.id.conceitosOp2RadioButton);
        op3RadioButton = findViewById(R.id.conceitosOp3RadioButton);
        op4RadioButton = findViewById(R.id.conceitosOp4RadioButton);
        op5RadioButton = findViewById(R.id.conceitosOp5RadioButton);
        perguntasProgressBar = findViewById(R.id.conceitosProgressBar);
        responderButton = findViewById(R.id.conceitosResponderButton);
        concluirButton = findViewById(R.id.conceitosConcluirButton);

        WebSettings webSettings = conceitosWebView.getSettings();
        webSettings.setJavaScriptEnabled(true);
        webSettings.setDomStorageEnabled(true);
        webSettings.setLoadWithOverviewMode(true);
        webSettings.setUseWideViewPort(true);
        webSettings.setBuiltInZoomControls(false);
        webSettings.setDisplayZoomControls(false);
        webSettings.setSupportZoom(false);
        webSettings.setDefaultTextEncodingName("utf-8");
        webSettings.setAllowFileAccessFromFileURLs(true);
        webSettings.setDefaultFontSize((int)getResources().getDimension(R.dimen.tam_fonte_texto));
        conteudo();
        novaPergunta();
    }

    private void conteudo(){
        //List<TypedArray> ta = Arrays.asList(getResources().obtainTypedArray(R.array.conceitos_barragens));
        Intent it = getIntent();
        if(it!=null){
            Bundle params = it.getExtras();
            if(params!=null){
                conceito = params.getParcelable("conceito");
            }
        }
        perguntas = new ArrayList<>();
        perguntas.add(conceito.getPergunta1());
        perguntas.add(conceito.getPergunta2());
        perguntas.add(conceito.getPergunta3());
        perguntas.add(conceito.getPergunta4());
        perguntas.add(conceito.getPergunta5());
        Collections.shuffle(perguntas);
        tituloTextView.setText(conceito.getTitulo());
        conceitosWebView.loadUrl(conceito.getTexto());
        /*if(conceito.getFormula().equals("")){
            formulaMathView.setVisibility(View.INVISIBLE);
        }else{
            formulaMathView.setText(conceito.getFormula());
        }*/
    }

    private void novaPergunta(){
        List<String> atual = new ArrayList<String>(perguntas.get(qtdePerguntas));
        enunciadoTextView.setText(atual.get(0));
        resposta = null;
        resposta = atual.get(1);
        atual.remove(0);
        Collections.shuffle(atual);
        op1RadioButton.setText(atual.get(0));
        op2RadioButton.setText(atual.get(1));
        op3RadioButton.setText(atual.get(2));
        op4RadioButton.setText(atual.get(3));
        op5RadioButton.setText(atual.get(4));
    }

    public void responderPerguntaConceitos(View view){
        if(perguntaRadioGroup.getCheckedRadioButtonId() == -1){
            Toast.makeText(this, this.getResources().getString(R.string.conceitos_alternativa_nao_selecionada), Toast.LENGTH_LONG).show();
        }else{
            if (op1RadioButton.isChecked()){
                selecionada = op1RadioButton.getText().toString();
            }
            if (op2RadioButton.isChecked()){
                selecionada = op2RadioButton.getText().toString();
            }
            if (op3RadioButton.isChecked()){
                selecionada = op3RadioButton.getText().toString();
            }
            if (op4RadioButton.isChecked()){
                selecionada = op4RadioButton.getText().toString();
            }
            if (op5RadioButton.isChecked()){
                selecionada = op5RadioButton.getText().toString();
            }
            if(selecionada.equals(resposta)){
                Toast.makeText(this, this.getResources().getString(R.string.conceitos_questao_correta), Toast.LENGTH_LONG).show();
                acertos++;
            }else{
                Toast.makeText(this, this.getResources().getString(R.string.conceitos_questao_incorreta), Toast.LENGTH_LONG).show();
            }

            qtdePerguntas++;
            perguntasProgressBar.setProgress(qtdePerguntas);
            perguntaRadioGroup.clearCheck();
            if(qtdePerguntas < this.getResources().getInteger(R.integer.conceitos_num_questoes)){
                novaPergunta();
            }else{
                concluirButton.setVisibility(View.VISIBLE);
                setPerguntaEnabled(false);
                responderButton.setVisibility(View.INVISIBLE);
            }
        }
    }

    public void concluirConceito(View view){
        if(acertos >= this.getResources().getInteger(R.integer.conceitos_min_acertos)){
            feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.conceitos_concluido), acertos, conceito.getTitulo());
            Intent it = new Intent(ConceitosActivity.this, MainActivity.class);
            Bundle params = new Bundle();
            params.putBoolean("hasFeedback", true);
            params.putString("feedback", feedback);
            params.putInt("figmascote", R.drawable.mascote_9);
            params.putInt("animacao", 0);
            params.putBoolean("hasUpdate", true);
            params.putInt("posModulo", conceito.getPosModulo());
            params.putInt("posCapitulo", conceito.getPosCapitulo());
            it.putExtras(params);
            startActivity(it);
        }else{
            feedback = String.format(Locale.getDefault(),this.getResources().getString(R.string.conceitos_nao_concluido),this.getResources().getInteger(R.integer.conceitos_min_acertos));
            perguntasProgressBar.setProgress(qtdePerguntas);
            concluirButton.setVisibility(View.INVISIBLE);
            setPerguntaEnabled(true);
            responderButton.setVisibility(View.VISIBLE);
            acertos = 0;
            qtdePerguntas = 0;
            Toast.makeText(this, feedback, Toast.LENGTH_LONG).show();
        }
        perguntasProgressBar.setProgress(0);
    }

    private void setPerguntaEnabled(boolean ativo){
        if(ativo){
            op1RadioButton.setEnabled(true);
            op2RadioButton.setEnabled(true);
            op3RadioButton.setEnabled(true);
            op4RadioButton.setEnabled(true);
            op5RadioButton.setEnabled(true);
        }else{
            perguntaRadioGroup.clearCheck();
            op1RadioButton.setEnabled(false);
            op2RadioButton.setEnabled(false);
            op3RadioButton.setEnabled(false);
            op4RadioButton.setEnabled(false);
            op5RadioButton.setEnabled(false);
        }
    }
}