package com.example.dams;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link DeslizamentoFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class DeslizamentoFragment extends Fragment {

    private Button simularButton;
    private String feedback;
    private EditText fhEditText, csdaEditText, fvEditText, coesaoMinEditText, csdcEditText;
    private TextView csdaMinTextView, csdcMinTextView;
    private SimulacaoViewModel simulacaoViewModel;
    private Number somafhU, csdaU, somafvU, coesaominnecU, csdcU;
    private double csdaMin;
    private final double csdcMin = 1;
    private boolean coesao = false;
    private NumberFormat format;

    public DeslizamentoFragment() {
        // Required empty public constructor
    }

    // TODO: Rename and change types and number of parameters
    public static DeslizamentoFragment newInstance() {
        return new DeslizamentoFragment();
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        simulacaoViewModel = new ViewModelProvider(getActivity()).get(SimulacaoViewModel.class);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_deslizamento, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        simularButton = getView().findViewById(R.id.deslizamentoButton);
        fhEditText = getView().findViewById(R.id.deslizamentoAtritoFHEditText);
        csdaEditText = getView().findViewById(R.id.deslizamentoAtritoCSDEditText);
        fvEditText = getView().findViewById(R.id.deslizamentoCoesaoFVEditText);
        coesaoMinEditText = getView().findViewById(R.id.deslizamentoCoesaoMinNecEditText);
        csdcEditText = getView().findViewById(R.id.deslizamentoCoesaoCSDEditText);
        csdaMinTextView = getView().findViewById(R.id.deslizamentoAtritoCSDminTextView);
        csdcMinTextView = getView().findViewById(R.id.deslizamentoCoesaoCSDminTextView);

        format = NumberFormat.getInstance(Locale.getDefault());
        try {
            csdaMin = format.parse(simulacaoViewModel.getSimulacao().getValue().getCmin().get(2)).doubleValue();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        csdaMinTextView.setText(String.format(Locale.getDefault(),"< %.2f",csdaMin));
        csdcMinTextView.setText(String.format(Locale.getDefault(),"< %.2f",csdcMin));
        csdaMinTextView.setTextColor(getResources().getColor(R.color.design_default_color_error));
        csdcMinTextView.setTextColor(getResources().getColor(R.color.design_default_color_error));
        simulacaoViewModel.getSimulacao().getValue().simular();
        listeners();
    }

    private void listeners() {

        fhEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_deslizamento_atrito_fh_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(3));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        coesaoMinEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_deslizamento_coesao_min_nec_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(6));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        csdaEditText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }
            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                try{
                    if(format.parse(csdaEditText.getText().toString()).doubleValue() < csdaMin){
                        csdaMinTextView.setText(String.format(Locale.getDefault(),"< %.2f",csdaMin));
                        csdaMinTextView.setTextColor(getResources().getColor(R.color.design_default_color_error));
                    }else if(format.parse(csdaEditText.getText().toString()).doubleValue() == csdaMin){
                        csdaMinTextView.setText(String.format(Locale.getDefault(),"= %.2f",csdaMin));
                        csdaMinTextView.setTextColor(getResources().getColor(R.color.lime));
                    }else{
                        csdaMinTextView.setText(String.format(Locale.getDefault(),"> %.2f",csdaMin));
                        csdaMinTextView.setTextColor(getResources().getColor(R.color.lime));
                    }
                }catch (NumberFormatException e){
                    csdaMinTextView.setText(String.format(Locale.getDefault(),"< %.2f",csdaMin));
                    csdaMinTextView.setTextColor(getResources().getColor(R.color.design_default_color_error));
                }catch (Exception e){
                }
            }
            @Override
            public void afterTextChanged(Editable s) {
            }
        });

        csdcEditText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }
            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                try{
                    if(format.parse(csdcEditText.getText().toString()).doubleValue() < csdcMin){
                        csdcMinTextView.setText(String.format(Locale.getDefault(),"< %.2f",csdcMin));
                        csdcMinTextView.setTextColor(getResources().getColor(R.color.design_default_color_error));
                    }else if(format.parse(csdcEditText.getText().toString()).doubleValue() == csdcMin){
                        csdcMinTextView.setText(String.format(Locale.getDefault(),"= %.2f",csdcMin));
                        csdcMinTextView.setTextColor(getResources().getColor(R.color.lime));
                    }else{
                        csdcMinTextView.setText(String.format(Locale.getDefault(),"> %.2f",csdcMin));
                        csdcMinTextView.setTextColor(getResources().getColor(R.color.lime));
                    }
                }catch (NumberFormatException e){
                    csdcMinTextView.setText(String.format(Locale.getDefault(),"< %.2f",csdcMin));
                    csdcMinTextView.setTextColor(getResources().getColor(R.color.design_default_color_error));
                }catch (Exception e){
                }
            }
            @Override
            public void afterTextChanged(Editable s) {
            }
        });

        simularButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(coesao){
                    try{
                        somafvU = format.parse(fvEditText.getText().toString());
                        coesaominnecU = format.parse(coesaoMinEditText.getText().toString());
                        csdcU = format.parse(csdcEditText.getText().toString());
                        simulacaoViewModel.getSimulacao().getValue().simularDeslizamentoCoesao();
                        simulacaoViewModel.getSimulacao().getValue().obterFeedbackDeslizamentoCoesao(somafvU.doubleValue(), coesaominnecU.doubleValue(), csdcU.doubleValue());
                        simulacaoViewModel.setSimulacao(simulacaoViewModel.getSimulacao().getValue());
                        feedback="";
                    }catch (Exception e){
                        feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.aviso_campos_nao_preenchidos));
                    }
                }else{
                    try{
                        somafhU = format.parse(fhEditText.getText().toString());
                        csdaU = format.parse(csdaEditText.getText().toString());
                        coesao = simulacaoViewModel.getSimulacao().getValue().obterFeedbackDeslizamentoAtrito(somafhU.doubleValue(), csdaU.doubleValue());
                        simulacaoViewModel.setSimulacao(simulacaoViewModel.getSimulacao().getValue());
                        if(coesao){
                            fvEditText.setEnabled(true);
                            coesaoMinEditText.setEnabled(true);
                            csdcEditText.setEnabled(true);
                            fhEditText.setEnabled(false);
                            csdaEditText.setEnabled(false);
                        }
                        feedback="";
                    }catch (Exception e){
                        feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.aviso_campos_nao_preenchidos));
                    }
                }
                if(!feedback.isEmpty()){
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

    }
}