package com.example.dams;

import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.VideoView;

import com.bumptech.glide.Glide;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link FeedbackFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class FeedbackFragment extends Fragment {

    private VideoView animacaoVideoView;
    private ImageView mascoteImageView;
    private TextView feedbackTextView;
    private String feedback;
    private int figmascote, animacao;
    private List<String> linksAnimacoes;

    public FeedbackFragment() {
        // Required empty public constructor
    }

    public static FeedbackFragment newInstance(String feedback, int figmascote, int animacao) {
        FeedbackFragment fragment = new FeedbackFragment();
        Bundle args = new Bundle();
        args.putString("feedback", feedback);
        args.putInt("figmascote", figmascote);
        args.putInt("animacao", animacao);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            feedback = getArguments().getString("feedback");
            figmascote = getArguments().getInt("figmascote");
            animacao = getArguments().getInt("animacao");
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_feedback, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        animacaoVideoView =  getView().findViewById(R.id.feedbackVideoView);
        mascoteImageView = getView().findViewById(R.id.feedbackImageView);
        feedbackTextView = getView().findViewById(R.id.feedbackTextView);
        Glide.with(this).load(figmascote).into(mascoteImageView);
        feedbackTextView.setText(feedback);
        if(animacao > 0){ //Da pasta raw - animacao como referência id
            animacaoVideoView.setVisibility(View.VISIBLE);
            animacaoVideoView.setVideoPath("android.resource://"+getContext().getPackageName()+"/"+animacao); //3gp, wmv, mp4
            animacaoVideoView.start();
            looping();
        }
        /*if(animacao >= 0){ //Da internet - animacao como index
            animacaoVideoView.setVisibility(View.VISIBLE);
            linksAnimacoes = new ArrayList<>(Arrays.asList(getResources().getStringArray(R.array.links_animacoes)));
            Uri uri = Uri.parse(linksAnimacoes.get(animacao));
            animacaoVideoView.setVideoURI(uri);
            animacaoVideoView.start();
        }*/
    }

    private void looping() {
        animacaoVideoView.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
            @Override
            public void onPrepared(MediaPlayer mp) {
                mp.setLooping(true);
            }
        });
    }

}