package com.example.dams;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.res.ResourcesCompat;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;

import com.bumptech.glide.Glide;

import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

public class InformarNiveisActivity extends AppCompatActivity {

    private ImageView niveisImageView;
    private EditText mEditText, jEditText, gamaaEditText;
    private Button confirmarNiveis;
    private Simulacao simulacao;
    private int destinoSimulacao;
    private String feedback;
    private Number m, j, gamaa;
    private NumberFormat format;
    private List<List<String>> cmin;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_informar_niveis);
        niveisImageView = findViewById(R.id.niveisImageView);
        mEditText = findViewById(R.id.niveisMEditText);
        jEditText = findViewById(R.id.niveisJEditText);
        gamaaEditText = findViewById(R.id.niveisGamaAEditText);
        confirmarNiveis = findViewById(R.id.niveisButton);
        format = NumberFormat.getInstance(Locale.getDefault());

        cmin = new ArrayList<>();
        Intent it = getIntent();
        if(it!=null){
            Bundle params = it.getExtras();
            if(params!=null){
                simulacao = params.getParcelable("simulacao");
                destinoSimulacao = params.getInt("destino");
                ArrayList<String> ccn = new ArrayList<String>(params.getStringArrayList("cmin_ccn"));
                ArrayList<String> cce = new ArrayList<String>(params.getStringArrayList("cmin_cce"));
                ArrayList<String> ccl = new ArrayList<String>(params.getStringArrayList("cmin_ccl"));
                ArrayList<String> ccc = new ArrayList<String>(params.getStringArrayList("cmin_ccc"));
                cmin.add(ccn);
                cmin.add(cce);
                cmin.add(ccl);
                cmin.add(ccc);
            }
        }
        if(simulacao instanceof Secao1){
            Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao1_niveis,null)).into(niveisImageView);
            //niveisImageView.setImageResource(R.drawable.secao1_niveis);
        }else if(simulacao instanceof Secao2){
            Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao2_niveis,null)).into(niveisImageView);
            //niveisImageView.setImageResource(R.drawable.secao2_niveis);
        }else if(simulacao instanceof Secao3){
            Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao3_niveis,null)).into(niveisImageView);
            //niveisImageView.setImageResource(R.drawable.secao3_niveis);
        }else if(simulacao instanceof Secao4){
            Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao4_niveis,null)).into(niveisImageView);
            //niveisImageView.setImageResource(R.drawable.secao4_niveis);
        }
        listeners();
    }

    public void listeners(){
        mEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.informar_niveis_m_hint), simulacao.getUnidades().get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        jEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.informar_niveis_j_hint), simulacao.getUnidades().get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        gamaaEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.informar_niveis_gama_hint), simulacao.getUnidades().get(1));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        confirmarNiveis.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                try{
                    m = format.parse(mEditText.getText().toString());
                    j = format.parse(jEditText.getText().toString());
                    gamaa = format.parse(gamaaEditText.getText().toString());
                    if(m.doubleValue() < format.parse(view.getContext().getResources().getString(R.string.informar_niveis_m_min)).doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_invalido),
                                view.getContext().getResources().getString(R.string.informar_niveis_m_hint),
                                format.parse(view.getContext().getResources().getString(R.string.informar_niveis_m_min)).doubleValue(),
                                simulacao.getUnidades().get(0));
                    }else if(j.doubleValue() < 0){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_negativo),
                                view.getContext().getResources().getString(R.string.informar_niveis_j_hint));
                    }else if(gamaa.doubleValue() < format.parse(view.getContext().getResources().getString(R.string.informar_niveis_gama_min)).doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_invalido),
                                view.getContext().getResources().getString(R.string.informar_niveis_gama_hint),
                                format.parse(view.getContext().getResources().getString(R.string.informar_niveis_gama_min)).doubleValue(),
                                simulacao.getUnidades().get(1));
                    }else if(simulacao.getH() < m.doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro),
                                view.getContext().getResources().getString(R.string.selecionar_secao_h_hint), view.getContext().getResources().getString(R.string.informar_niveis_m_hint));
                    }else if(m.doubleValue() < j.doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro),
                                view.getContext().getResources().getString(R.string.informar_niveis_m_hint), view.getContext().getResources().getString(R.string.informar_niveis_j_hint));
                    }else{
                        feedback = "";
                        simulacao.setM(m.doubleValue());
                        simulacao.setJ(j.doubleValue());
                        simulacao.setGamaa(gamaa.doubleValue());
                        Intent it = new Intent();
                        Bundle params = new Bundle();
                        if(destinoSimulacao == 1){
                            it.setClass(view.getContext(), SimulacaoActivity.class); //SimulacaoActivity - PressoesFragment
                        }else{
                            it.setClass(view.getContext(), SimularCCActivity.class); //SimularCCActivity (destinos 3,4,5,6)
                            params.putStringArrayList("cmin_ccn", (ArrayList<String>) cmin.get(0));
                            params.putStringArrayList("cmin_cce", (ArrayList<String>) cmin.get(1));
                            params.putStringArrayList("cmin_ccl", (ArrayList<String>) cmin.get(2));
                            params.putStringArrayList("cmin_ccc", (ArrayList<String>) cmin.get(3));
                        }
                        params.putInt("destino", destinoSimulacao);
                        if(simulacao instanceof Secao1){
                            params.putParcelable("simulacao", (Secao1)simulacao);
                        }else if(simulacao instanceof Secao2){
                            params.putParcelable("simulacao", (Secao2)simulacao);
                        }else if(simulacao instanceof Secao3){
                            params.putParcelable("simulacao", (Secao3)simulacao);
                        }else if(simulacao instanceof Secao4){
                            params.putParcelable("simulacao", (Secao4)simulacao);
                        }
                        it.putExtras(params);
                        view.getContext().startActivity(it);
                        //feedback = "M= " + m + simulacao.getUnidades().get(0) + "; J= " + j + simulacao.getUnidades().get(0) + "; GamaA= " + gamaa + simulacao.getUnidades().get(1);
                    }
                }catch (Exception e){
                    feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.aviso_campos_nao_preenchidos));
                }
                if(!feedback.isEmpty()){
                    Toast.makeText(view.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });
    }
}