package com.example.dams;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.SwitchCompat;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Switch;
import android.widget.Toast;

import com.google.android.material.switchmaterial.SwitchMaterial;

import java.text.NumberFormat;
import java.util.Locale;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link PressoesFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class PressoesFragment extends Fragment {

    private Button simularButton;
    private String feedback;
    private EditText eamEditText, cgyeamEditText, eajEditText, cgyeajEditText, pesoajEditText, cgxpesoajEditText, pesoamEditText, cgxpesoamEditText;
    private SwitchCompat eamSwitch, eajSwitch, pesoajSwitch, pesoamSwitch;
    private SimulacaoViewModel simulacaoViewModel;
    private Number eamU, cgyeamU, eajU, cgyeajU, pesoajU, cgxpesoajU, pesoamU, cgxpesoamU;
    private boolean meamU, meajU, mpesoajU, mpesoamU;
    private NumberFormat format;

    public PressoesFragment() {
        // Required empty public constructor
    }

    // TODO: Rename and change types and number of parameters
    public static PressoesFragment newInstance() {
        return new PressoesFragment();
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        simulacaoViewModel = new ViewModelProvider(getActivity()).get(SimulacaoViewModel.class);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_pressoes, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        simularButton = getView().findViewById(R.id.pressoesButton);
        eamEditText = getView().findViewById(R.id.pressoesEAMEditText);
        cgyeamEditText = getView().findViewById(R.id.pressoesCGYEAMEditText);
        eajEditText = getView().findViewById(R.id.pressoesEAJEditText);
        cgyeajEditText = getView().findViewById(R.id.pressoesCGYEAJEditText);
        pesoajEditText = getView().findViewById(R.id.pressoesPesoAJEditText);
        cgxpesoajEditText = getView().findViewById(R.id.pressoesCGXPesoAJEditText);
        pesoamEditText = getView().findViewById(R.id.pressoesPesoAMEditText);
        cgxpesoamEditText = getView().findViewById(R.id.pressoesCGXPesoAMEditText);
        eamSwitch = getView().findViewById(R.id.pressoesEAMSwitch);
        eajSwitch = getView().findViewById(R.id.pressoesEAJSwitch);
        pesoajSwitch = getView().findViewById(R.id.pressoesPesoAJSwitch);
        pesoamSwitch = getView().findViewById(R.id.pressoesPesoAMSwitch);
        format = NumberFormat.getInstance(Locale.getDefault());
        if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1 || simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
            pesoamEditText.setEnabled(false);
            cgxpesoamEditText.setEnabled(false);
            pesoamSwitch.setEnabled(false);
        }
        simulacaoViewModel.getSimulacao().getValue().simular();
        listeners();
    }

    private void listeners() {
        eamEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_pressoes_eam_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(3));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        cgyeamEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_cgy_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        eajEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_pressoes_eaj_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(3));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        cgyeajEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_cgy_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        pesoajEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_pressoes_pesoaj_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(3));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        cgxpesoajEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_cgx_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        pesoamEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_pressoes_pesoam_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(3));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        cgxpesoamEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_cgx_hint), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        simularButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try{
                    eamU = format.parse(eamEditText.getText().toString());
                    cgyeamU = format.parse(cgyeamEditText.getText().toString());
                    eajU = format.parse(eajEditText.getText().toString());
                    cgyeajU = format.parse(cgyeajEditText.getText().toString());
                    pesoajU = format.parse(pesoajEditText.getText().toString());
                    cgxpesoajU = format.parse(cgxpesoajEditText.getText().toString());
                    meamU = eamSwitch.isChecked();
                    meajU = eajSwitch.isChecked();
                    mpesoajU = pesoajSwitch.isChecked();
                    if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2 || simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
                        pesoamU = format.parse(pesoamEditText.getText().toString());
                        cgxpesoamU = format.parse(cgxpesoamEditText.getText().toString());
                        mpesoamU = pesoamSwitch.isChecked();
                        simulacaoViewModel.getSimulacao().getValue().obterFeedbackForcaPressao(eamU.doubleValue(), cgyeamU.doubleValue(), meamU, eajU.doubleValue(), cgyeajU.doubleValue(),
                                meajU, pesoajU.doubleValue(), cgxpesoajU.doubleValue(), mpesoajU, pesoamU.doubleValue(), cgxpesoamU.doubleValue(), mpesoamU);
                    }else{
                        simulacaoViewModel.getSimulacao().getValue().obterFeedbackForcaPressao(eamU.doubleValue(), cgyeamU.doubleValue(), meamU, eajU.doubleValue(), cgyeajU.doubleValue(),
                                meajU, pesoajU.doubleValue(), cgxpesoajU.doubleValue(), mpesoajU, 0, 0, false);
                    }
                    simulacaoViewModel.setSimulacao(simulacaoViewModel.getSimulacao().getValue());
                    feedback="";
                }catch (Exception e){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.aviso_campos_nao_preenchidos));
                }

                if(!feedback.isEmpty()){
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

    }
}