package com.example.dams;

import android.os.Parcel;
import android.os.Parcelable;

import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.Locale;

public class Secao3 extends Simulacao implements Parcelable {
    private double c;

    public Secao3() {
    }

    public Secao3(int posModulo, int posCapitulo, String titulo, double a, double b, double h, double gamac, double c) {
        super(posModulo, posCapitulo, titulo, a, b, h, gamac);
        this.c = c;
    }

    public void simular() {
        calcularPeso();
        calcularCGX();
        calcularCGY();
        calcularEAM();
        calcularCGYEAM();
        calcularEAJ();
        calcularCGYEAJ();
        calcularPesoAJ();
        calcularCGXPesoAJ();
        calcularSubpressao();
        calcularCGXSubpressao();
        calcularCSF();
        calcularSomaMEst();
        calcularSomaMDes();
        calcularCST();
        calcularSomaFH();
        calcularSomaFV();
        calcularCSDa();
        calcularTensaoMax();
        calcularTensaoMin();
        calcularPorcBaseComp();
    }

    public void simularDeslizamentoCoesao() {
        calcularCoesaoMinNec();
        calcularCSDc();
    }

    public void simularFissura() {
        calcularFissura();
        calcularNovosCoefTenPorc();
    }

    protected Secao3(Parcel in) {
        titulo = in.readString();
        posModulo = in.readInt();
        posCapitulo = in.readInt();
        feedback = in.readString();
        cc = in.readInt();
        figmascote = in.readInt();
        animacao = in.readInt();
        cmin = in.createStringArrayList();
        unidades = in.createStringArrayList();
        tolerancia = in.readDouble();
        a = in.readDouble();
        b = in.readDouble();
        h = in.readDouble();
        gamac = in.readDouble();
        peso = in.readDouble();
        cgx = in.readDouble();
        cgy = in.readDouble();
        m = in.readDouble();
        j = in.readDouble();
        gamaa = in.readDouble();
        eam = in.readDouble();
        cgyeam = in.readDouble();
        eaj = in.readDouble();
        cgyeaj = in.readDouble();
        pesoaj = in.readDouble();
        cgxpesoaj = in.readDouble();
        subpressao = in.readDouble();
        cgxsubpressao = in.readDouble();
        csf = in.readDouble();
        somamest = in.readDouble();
        somamdes = in.readDouble();
        cst = in.readDouble();
        somafh = in.readDouble();
        somafv = in.readDouble();
        fi = in.readDouble();
        csda = in.readDouble();
        coesaominnec = in.readDouble();
        coesaomax = in.readDouble();
        csdc = in.readDouble();
        tensaomax = in.readDouble();
        tensaomin = in.readDouble();
        porcbasecomp = in.readDouble();
        fissura = in.readDouble();
        c = in.readDouble();
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(titulo);
        dest.writeInt(posModulo);
        dest.writeInt(posCapitulo);
        dest.writeString(feedback);
        dest.writeInt(cc);
        dest.writeInt(figmascote);
        dest.writeInt(animacao);
        dest.writeStringList(cmin);
        dest.writeStringList(unidades);
        dest.writeDouble(tolerancia);
        dest.writeDouble(a);
        dest.writeDouble(b);
        dest.writeDouble(h);
        dest.writeDouble(gamac);
        dest.writeDouble(peso);
        dest.writeDouble(cgx);
        dest.writeDouble(cgy);
        dest.writeDouble(m);
        dest.writeDouble(j);
        dest.writeDouble(gamaa);
        dest.writeDouble(eam);
        dest.writeDouble(cgyeam);
        dest.writeDouble(eaj);
        dest.writeDouble(cgyeaj);
        dest.writeDouble(pesoaj);
        dest.writeDouble(cgxpesoaj);
        dest.writeDouble(subpressao);
        dest.writeDouble(cgxsubpressao);
        dest.writeDouble(csf);
        dest.writeDouble(somamest);
        dest.writeDouble(somamdes);
        dest.writeDouble(cst);
        dest.writeDouble(somafh);
        dest.writeDouble(somafv);
        dest.writeDouble(fi);
        dest.writeDouble(csda);
        dest.writeDouble(coesaominnec);
        dest.writeDouble(coesaomax);
        dest.writeDouble(csdc);
        dest.writeDouble(tensaomax);
        dest.writeDouble(tensaomin);
        dest.writeDouble(porcbasecomp);
        dest.writeDouble(fissura);
        dest.writeDouble(c);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<Secao3> CREATOR = new Creator<Secao3>() {
        @Override
        public Secao3 createFromParcel(Parcel in) {
            return new Secao3(in);
        }

        @Override
        public Secao3[] newArray(int size) {
            return new Secao3[size];
        }
    };

    public void calcularPeso() {
        this.peso = gamac * (a * h + (b - a) * (h - c)/2);
    }

    public void calcularCGX() {
        this.cgx = ((a * h) * (b - a/2) + ((b - a) * (h - c) / 2) * ((b - a) * 2/3)) / ((a * h) + ((b - a) * (h - c) / 2));
    }

    public void calcularCGY() {
        this.cgy = ((a * h) * (h/2) + ((b - a) * (h - c) / 2) * ((h - c)/3)) / ((a * h) + ((b - a) * (h - c) / 2));
    }

    public void calcularEAM() {
        this.eam = gamaa * m * m/2;
    }

    public void calcularCGYEAM() {
        this.cgyeam = m / 3;
    }

    public void calcularEAJ() {
        this.eaj = gamaa * j * j/2;
    }

    public void calcularCGYEAJ() {
        this.cgyeaj = j / 3;
    }

    public void calcularPesoAJ() {
        if(j <= (h - c)){
            this.pesoaj = gamaa * ((j * (b - a) / (h - c)) * (j/2));
        }else{
            this.pesoaj = gamaa * ((j + c + j - h) * (b - a)/2);
        }
    }

    public void calcularCGXPesoAJ() {
        if(j <= (h - c)){
            this.cgxpesoaj = (j * (b - a) / (h - c))/3;
        }else{
            this.cgxpesoaj = (((h - c) * (b - a)/2) * (b - a)/3 + ((b - a) * (c + j - h)) * (b - a)/2) / (((h - c) * (b - a)/2) + ((b - a) * (c + j - h)));
        }
    }

    public void calcularSubpressao() {
        this.subpressao = gamaa * (m + j) * b/2;
    }

    public void calcularCGXSubpressao() {
        this.cgxsubpressao = ((j * b) * (b/2) + (m - j) * (b/2) * (b * 2/3)) / ((j * b) + (m - j) * (b/2));
    }

    public void calcularCSF() {
        this.csf = (peso + pesoaj) / subpressao;
    }

    public void calcularSomaMEst() {
        this.somamest = peso * cgx + pesoaj * cgxpesoaj + eaj * cgyeaj;
    }

    public void calcularSomaMDes() {
        this.somamdes = subpressao * cgxsubpressao + eam * cgyeam;
    }

    public void calcularCST() {
        this.cst = somamest / somamdes;
    }

    public void calcularSomaFH() {
        this.somafh = eam - eaj;
    }

    public void calcularSomaFV() {
        this.somafv = peso + pesoaj - subpressao;
    }

    public void calcularCSDa() {
        this.csda = somafv * Math.tan(Math.PI * fi / 180) / somafh;
    }

    public void calcularCoesaoMinNec() {
        this.coesaominnec = (somafh * parseDouble(cmin.get(3)) / b) - (somafv * Math.tan(Math.PI * fi / 180) * parseDouble(cmin.get(3)) / (parseDouble(cmin.get(2)) * b));
    }

    public void calcularCSDc() {
        this.csdc = (somafv * Math.tan(Math.PI * fi / 180) / (parseDouble(cmin.get(2)) * somafh)) + ((coesaomax * b) / (parseDouble(cmin.get(3)) * somafh));
    }

    public void calcularTensaoMax() {
        this.tensaomax = -((somafv / b) - ((somafv / (Math.pow(b,2)/6)) * ((b/2) - ((somamest - somamdes) / somafv))));
    }

    public void calcularTensaoMin() {
        this.tensaomin = -((somafv / b) + ((somafv / (Math.pow(b,2)/6)) * ((b/2) - ((somamest - somamdes) / somafv))));
    }

    public void calcularPorcBaseComp() {
        if(tensaomin < 0 && tensaomax < 0){
            this.porcbasecomp = 100;
        }
        if(tensaomin > 0 && tensaomax > 0){
            this.porcbasecomp = 0;
        }
        if(tensaomin < 0 && tensaomax > 0){
            this.porcbasecomp = 100 - 100 * (tensaomax / (tensaomax + tensaomin * (-1)));
        }
    }

    public void calcularFissura() {
        this.fissura = 0;
        double terco = (b - fissura)/3;
        double mf = (somamest - somamdes) / somafv;
        DecimalFormat df = new DecimalFormat("#.0000");
        df.setRoundingMode(RoundingMode.HALF_EVEN);
        while(!df.format(terco).equals(df.format(mf)) && fissura <= b){
            this.fissura = fissura + 0.001;
            this.subpressao = gamaa * (fissura * m + (b - fissura) * j + ((m - j) * (b - fissura) / 2));
            this.somamdes = gamaa * ((fissura * m * (b - fissura/2)) + (j * Math.pow((b - fissura),2))/2 + Math.pow(m,3)/6 + ((m - j) * Math.pow((b - fissura),2))/3);
            this.calcularSomaFV();
            terco = (b - fissura)/3;
            mf = (somamest - somamdes) / somafv;
        }
    }

    public void calcularNovosCoefTenPorc() {
        this.calcularCSF();
        this.calcularCST();
        this.calcularCSDa();
        this.csdc = (somafv * Math.tan(Math.PI * fi / 180) / (parseDouble(cmin.get(2)) * somafh)) + ((coesaomax * (b - fissura)) / (parseDouble(cmin.get(3)) * somafh));
        this.tensaomax = -((somafv / (b - fissura)) - ((somafv / (Math.pow((b - fissura),2)/6)) * (((b - fissura)/2) - ((somamest - somamdes) / somafv))));
        this.tensaomin = -((somafv / (b - fissura)) + ((somafv / (Math.pow((b - fissura),2)/6)) * (((b - fissura)/2) - ((somamest - somamdes) / somafv))));
        this.porcbasecomp = 100 - 100 * (fissura / b);
    }

    @Override
    public double getC() {
        return c;
    }
    @Override
    public void setC(double c) {
        this.c = c;
    }

    public void obterFeedbackCentroMassa(double pesoU, double cgxU, double cgyU){
        if(pesoU == -1){ //Apresentação Inicial
            this.feedback = String.format(Locale.getDefault(),"Que tal relembrarmos um pouco como calcular centro de gravidade? Acho um bom começo.");
            this.figmascote = R.drawable.mascote_9;
        }else{
            boolean apeso = acertouDouble(peso, pesoU);
            boolean acgx = acertouDouble(cgx, cgxU);
            boolean acgy = acertouDouble(cgy, cgyU);
            if(!apeso && !acgx && !acgy){
                //this.feedback = String.format("Peso= %.2f; CGX= %.2f; CGY= %.2f", peso, cgx, cgy);
                this.feedback = String.format("Nenhum de nossos resultados conferem. Talvez se você dividir a seção em figuras mais simples pode tornar os cáculos mais fáceis.");
                this.figmascote = R.drawable.mascote_11;
            }else if(!apeso && (acgx || acgy)){
                this.feedback = String.format("Como calculou o peso por unidade de largura? Considerou o peso específico?");
                this.figmascote = R.drawable.mascote_10;
            }else if(apeso && (!acgx || !acgy)){
                this.feedback = String.format("O peso parece estar correto, mas o local do seu centro de massa está diferente do meu.");
                this.figmascote = R.drawable.mascote_10;
            }else if(apeso && acgx && acgy){
                this.feedback = String.format("Tinha certeza que você era o engenheiro(a) certo para este desafio! Vamos iniciar as escavações!");
                this.figmascote = R.drawable.mascote_5;
                this.fim = true;
            }
        }
    }

    public void obterFeedbackForcaPressao(double eamU, double cgyeamU, boolean meamU, double eajU, double cgyeajU, boolean meajU, double pesoajU, double cgxpesoajU, boolean mpesoajU, double pesoamU, double cgxpesoamU, boolean mpesoamU){
        if(eamU == -1){ //Apresentação Inicial
            this.feedback = "Este será um passo essencial na nossa construção. Vamos calcular os volumes destes diagramas de pressão?";
            this.figmascote = R.drawable.mascote_9;
        }else{
            boolean aeam = acertouDouble(eam, eamU);
            boolean acgyeam = acertouDouble(cgyeam, cgyeamU);
            boolean ameam = !meamU;
            boolean aeaj = acertouDouble(eaj, eajU);
            boolean acgyeaj = acertouDouble(cgyeaj, cgyeajU);
            boolean ameaj = meajU;
            boolean apesoaj = acertouDouble(pesoaj, pesoajU);
            boolean acgxpesoaj = acertouDouble(cgxpesoaj, cgxpesoajU);
            boolean ampesoaj = mpesoajU;
            //boolean apesoam = acertouDouble(pesoam, pesoamU); //Seções 2 e 4
            //boolean acgxpesoam = acertouDouble(cgxpesoam, cgxpesoamU); //Seções 2 e 4
            //boolean ampesoam = mpesoamU; //Seções 2 e 4
            if(!aeam || !aeaj || !apesoaj){
                this.feedback = String.format("Alguma força parece não estar correta...");
                this.figmascote = R.drawable.mascote_10;
            }else if(!acgyeam || !acgyeaj || !acgxpesoaj){
                this.feedback = String.format("Estas excentricidades estão me confundindo. Considero a coordenada x ou y do centro de gravidade?");
                this.figmascote = R.drawable.mascote_10;
            }else if(!ameam || !ameaj || !ampesoaj){
                this.feedback = String.format("Vamos pensar melhor quais são as forças que estão estabilizando nosso dique. Tente alterar o sentido do momento.");
                this.figmascote = R.drawable.mascote_10;
            }else{
                this.feedback = "Graças a você poderemos começar as obras no canal de desvio.";
                this.figmascote = R.drawable.mascote_5;
                this.fim = true;
            }
        }
        //double eam, double cgyeam, double eaj, double cgyeaj, double pesoaj, double cgxpesoaj
    }

    public void obterFeedbackFlutuacao(double subpressaoU, double cgxsubpressaoU, boolean msubpressaoU, double csfU){
        if(subpressaoU == -1){ //Apresentação Inicial
            this.feedback = "Aqui vamos nós para nossa primeira verificação. Seria uma tragédia se nosso dique flutuasse!";
            this.figmascote = R.drawable.mascote_1;
            this.animacao = R.raw.dam_floating_s1;
        }else{
            boolean asubpressao = acertouDouble(subpressao, subpressaoU);
            boolean acgxsubpressao = acertouDouble(cgxsubpressao, cgxsubpressaoU);
            boolean amsubpressao= !msubpressaoU;
            boolean acsf = acertouDouble(csf, csfU);
            if(!asubpressao && !acgxsubpressao && !amsubpressao){
                //this.feedback = String.format("Subpressao= %.2f; CGX= %.2f; CSF= %.2f", subpressao, cgxsubpressao, csf);
                this.feedback = String.format("Este não é o caminho... Tente novamente.");
                this.figmascote = R.drawable.mascote_11;
                this.animacao = 0;
            }else if(asubpressao && !acgxsubpressao && !amsubpressao){
                this.feedback = String.format("Não estamos de acordo com esta excentricidade.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(!asubpressao && acgxsubpressao && !amsubpressao){
                this.feedback = String.format("Não esqueça de considerar o peso específico do fluido para calcular a força resultante.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(!asubpressao && !acgxsubpressao && amsubpressao){
                this.feedback = String.format("Não acredito que seja por este caminho.");
                this.figmascote = R.drawable.mascote_11;
                this.animacao = 0;
            }else if(asubpressao && acgxsubpressao && !amsubpressao){
                this.feedback = String.format("Tem certeza que a subpressão é estabilizante?");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(!asubpressao && acgxsubpressao && amsubpressao){
                this.feedback = String.format("Não esqueça de considerar o peso específico do fluido para calcular a força resultante.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(asubpressao && !acgxsubpressao && amsubpressao){
                this.feedback = String.format("Não estamos de acordo com esta excentricidade.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(acsf) {
                this.feedback = "Brilhante! Com este novo conhecimento podemos iniciar os trabalhos no leito do rio.";
                this.figmascote = R.drawable.mascote_5;
                if (csf < parseDouble(cmin.get(0))) {
                    this.animacao = R.raw.dam_floating_s1;
                } else {
                    this.animacao = R.raw.dam_sucess_s1;
                }
                this.fim = true;
            }else{
                this.feedback = "Está quase! Só falta acertarmos este coeficiente!";
                this.figmascote = R.drawable.mascote_9;
                this.animacao = 0;
            }
        }
    }

    public void obterFeedbackTombamento(double somamestU, double somamdesU, double cstU){
        if(somamestU == -1){ //Apresentação Inicial
            this.feedback = "Mais um desafio! Vamos escolher uma geometria que impeça nosso dique de tombar.";
            this.figmascote = R.drawable.mascote_1;
            this.animacao = R.raw.dam_tipping_s1;
        }else{
            boolean asomamest = acertouDouble(somamest, somamestU);
            boolean asomamdes = acertouDouble(somamdes, somamdesU);
            boolean acst = acertouDouble(cst, cstU);
            if(!asomamest && !asomamdes){
                //this.feedback = String.format("Est= %.2f; Des= %.2f; CST= %.2f", somamest, somamdes, cst);
                this.feedback = String.format("Se não classificarmos corretamente entre estabilizantes e desestabilizantes isso nunca dará certo.");
                this.figmascote = R.drawable.mascote_11;
                this.animacao = 0;
            }else if(asomamest && !asomamdes){
                this.feedback = String.format("Considerou todos os momentos desestabilizantes?");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(!asomamest && asomamdes){
                this.feedback = String.format("Considerou todos os momentos estabilizantes?");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(acst) {
                this.feedback = "Explêndido! Finalmente chegou a hora de construir nosso dique!";
                this.figmascote = R.drawable.mascote_5;
                if (cst < parseDouble(cmin.get(1))) {
                    this.animacao = R.raw.dam_tipping_s1;
                } else {
                    this.animacao = R.raw.dam_sucess_s1;
                }
                this.fim = true;
            }else{
                this.feedback = "Acho que agora só falta o coeficiente. Vamos tentar novamente.";
                this.figmascote = R.drawable.mascote_9;
                this.animacao = 0;
            }
        }
    }

    public boolean obterFeedbackDeslizamentoAtrito(double somafhU, double csdaU){
        boolean coesao = false;
        if(somafhU == -1){ //Apresentação Inicial
            this.feedback = "Nesta etapa vamos verificar se o atrito é suficiente para impedir o deslizamento do nosso dique.";
            this.figmascote = R.drawable.mascote_1;
            this.animacao = R.raw.dam_slidding_s1;
        }else{
            boolean asomafh = acertouDouble(somafh, somafhU);
            boolean acsda = acertouDouble(csda, csdaU);
            if(!asomafh){
                //this.feedback = String.format("SomaFH= %.2f; CSDa= %.2f", somafh, csda);
                this.feedback = "Lembre-se que forças de sentidos opostos tendem a se anular.";
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(acsda){
                if(csda < parseDouble(cmin.get(2))){
                    this.feedback = "Sensacional! Talvez se considerarmos a coesão nosso dique não escorregue.";
                    this.figmascote = R.drawable.mascote_5;
                    this.animacao = R.raw.dam_slidding_s1;
                    coesao = true;
                }else{
                    this.feedback = "Excelente trabalho! Já podemos encher nosso reservatório!";
                    this.figmascote = R.drawable.mascote_5;
                    this.animacao = R.raw.dam_sucess_s1;
                    this.fim = true;
                }
            }else{
                this.feedback = "Quase! Mas esse coeficiente relativo ao atrito não confere com o meu.";
                this.figmascote = R.drawable.mascote_9;
                this.animacao = 0;
            }
        }
        return coesao;
    }

    public void obterFeedbackDeslizamentoCoesao(double somafvU, double coesaominnecU, double csdcU){
        if(somafvU == -1){ //Apresentação Inicial
            this.feedback = "...";
            this.figmascote = R.drawable.mascote_1;
            this.animacao = R.raw.dam_slidding_s1;
        }else {
            boolean asomafv = acertouDouble(somafv, somafvU);
            boolean acoesaominnec = acertouDouble(coesaominnec, coesaominnecU);
            boolean acsdc = acertouDouble(csdc, csdcU);
            if(!asomafv){
                //this.feedback = String.format("SomaFV= %.2f; CoesaoMin= %.2f; CSDc= %.2f", somafv, coesaominnec, csdc);
                this.feedback = String.format("Não esqueça de verificar o que é positivo ou negativo no somatório das forças verticais.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(!acoesaominnec && !acsdc){
                this.feedback = String.format("Acho que devemos verificar novamente a coesão mínima necessária.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if (acoesaominnec && !acsdc) {
                this.feedback = String.format("Estamos chegando lá! Só devemos recalcular o coeficiente.");
                this.figmascote = R.drawable.mascote_9;
                this.animacao = 0;
            }else if (!acoesaominnec && acsdc) {
                this.feedback = String.format("Acho que devemos verificar novamente a coesão mínima necessária.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else{
                this.feedback = String.format("Excelente trabalho! Já podemos encher nosso reservatório!");
                this.figmascote = R.drawable.mascote_16;
                if(csdc < parseDouble(cmin.get(3))){
                    this.animacao = R.raw.dam_slidding_s1;
                }else{
                    this.animacao = R.raw.dam_sucess_s1;
                }
                this.fim = true;
            }
        }
    }

    public boolean obterFeedbackTensaoBase(double tensaomaxU, double tensaominU, double porcbasecompU){
        boolean fissura = false;
        if(tensaomaxU == -1){ //Apresentação Inicial
            this.feedback = "Preparado para o desafio final? Pelo que eu vi de você até aqui isso será moleza.";
            this.figmascote = R.drawable.mascote_5;
            this.animacao = R.raw.dam_break_s1;
        }else{
            boolean atensaomax = acertouDouble(tensaomax, tensaomaxU);
            boolean atensaomin = acertouDouble(tensaomin, tensaominU);
            boolean aporcbasecomp = acertouDouble(porcbasecomp, porcbasecompU);
            if(!atensaomax && !atensaomin){
                //this.feedback = String.format("TensaoMax= %.2f; TensaoMin= %.2f; PorcComp= %.2f", tensaomax, tensaomin, porcbasecomp);
                this.feedback = String.format("Estas tensões podem ser confusas de calcular. Lembre-se que no nosso caso estamos considerando uma base sempre retangular.");
                this.figmascote = R.drawable.mascote_11;
                this.animacao = 0;
            }else if(atensaomax && !atensaomin){
                this.feedback = String.format("A tensão máxima parece correta, mas a mínima não.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(!atensaomax && atensaomin){
                this.feedback = String.format("A tensão mínima parece correta, mas a máxima não.");
                this.figmascote = R.drawable.mascote_10;
                this.animacao = 0;
            }else if(aporcbasecomp){
                if(porcbasecomp < parseDouble(cmin.get(4))){
                    this.feedback = "Fantástico! Mas as tensões de tração estão nos atrapalhando. Será que com abertura de fissura conseguimos algo?";
                    this.figmascote = R.drawable.mascote_9;
                    this.animacao = R.raw.dam_break_s1;
                    fissura = true;
                }else{
                    this.feedback = "Eu sabia desde o princípio que conseguiria. Vamos inaugurar nossa usina hidrelétrica e quero que você seja nosso convidado de honra.";
                    this.figmascote = R.drawable.mascote_5;
                    this.animacao = R.raw.dam_sucess_s1;
                    this.fim = true;
                }
            }else{
                this.feedback = String.format("Confira a porcentagem da base comprimida. As tensões de compressão são negativas e de tração positivas.");
                this.figmascote = R.drawable.mascote_9;
                this.animacao = 0;
            }
        }
        return fissura;
    }

    public void obterFeedbackFissura(double csfU, double cstU, double csdaU, double csdcU, double tensaominU, double porcbasecompU){
        if(csfU == -1){ //Apresentação Inicial
            this.feedback = "...";
            this.figmascote = R.drawable.mascote_1;
            this.animacao = R.raw.dam_break_s1;
        }else{
            boolean acsf = acertouDouble(csf, csfU);
            boolean acst = acertouDouble(cst, cstU);
            boolean acsda = acertouDouble(csda, csdaU);
            boolean acsdc = acertouDouble(csdc, csdcU);
            boolean atensaomin = acertouDouble(tensaomin, tensaominU);
            boolean aporcbasecomp = acertouDouble(porcbasecomp, porcbasecompU);
            this.figmascote = R.drawable.mascote_10;
            this.animacao = 0;
            this.feedback = "Gostaria de conferir com meus cálculos? Deixa eu ver o que está igual aos meus resultados: ";
            if(acsf){this.feedback = " CSF ";}else{this.feedback = "";}
            if(acst){this.feedback = feedback + " CST ";}else{this.feedback = feedback + "";}
            if(acsda){this.feedback = feedback + " CSDa ";}else{this.feedback = feedback + "";}
            if(acsdc){this.feedback = feedback + " CSDc ";}else{this.feedback = feedback + "";}
            if(atensaomin){this.feedback = feedback + " Tensão Mínima ";}else{this.feedback = feedback + "";}
            if(aporcbasecomp){this.feedback = feedback + " Porcentagem da Base Comprimida ";}else{this.feedback = feedback + "";}
            //this.feedback = String.format("TensaoMin= %.2f; PorcComp= %.2f; CSF= %.2f; CST= %.2f; CSDa= %.2f; CSDc= %.2f;", tensaomin, porcbasecomp, csf, cst, csda, csdc);
            if(acsf && acst && acsda && acsdc && atensaomin && aporcbasecomp){
                this.figmascote = R.drawable.mascote_5;
                if(csf < parseDouble(cmin.get(0))){
                    this.feedback = "Eu sabia desde o princípio que conseguiria. Vamos inaugurar nossa usina hidrelétrica e quero que você seja nosso convidado de honra.";
                    this.animacao = R.raw.dam_floating_s1;
                }else if(cst < parseDouble(cmin.get(1))){
                    this.feedback = "Eu sabia desde o princípio que conseguiria. Vamos inaugurar nossa usina hidrelétrica e quero que você seja nosso convidado de honra.";
                    this.animacao = R.raw.dam_tipping_s1;
                }else if(csda < parseDouble(cmin.get(2)) && csdc < parseDouble(cmin.get(3))){
                    this.feedback = "Eu sabia desde o princípio que conseguiria. Vamos inaugurar nossa usina hidrelétrica e quero que você seja nosso convidado de honra.";
                    this.animacao = R.raw.dam_slidding_s1;
                }else if(porcbasecomp < parseDouble(cmin.get(4))){
                    this.feedback = "Eu sabia desde o princípio que conseguiria. Vamos inaugurar nossa usina hidrelétrica e quero que você seja nosso convidado de honra.";
                    this.animacao = R.raw.dam_break_s1;
                }else{
                    this.feedback = "Eu sabia desde o princípio que conseguiria. Vamos inaugurar nossa usina hidrelétrica e quero que você seja nosso convidado de honra.";
                    this.animacao = R.raw.dam_sucess_s1;
                }
                this.fim = true;
            }
        }
    }
}
