package com.example.dams;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.ScrollView;
import android.widget.TableLayout;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.GenericTypeIndicator;
import com.google.firebase.database.ValueEventListener;

import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.ExecutionException;

public class SelecionarSecaoActivity extends AppCompatActivity {

    private ScrollView secaoScrollView;
    private TableLayout secaoTable;
    private RadioGroup secaoRadioGroup;
    private RadioButton secao1RadioButton, secao2RadioButton, secao3RadioButton, secao4RadioButton;
    private EditText aEditText, bEditText, hEditText, cEditText, dEditText, gamaEditText, fiEditText, coesaoMaxEditText;
    private Button confirmarButton;
    private String feedback, titulo;
    private Number a, b, h, c, d, gama, fi, coesaomax;
    private List<String> unidades;
    private List<List<String>> cmin;
    private int destinoSimulacao, posModulo, posCapitulo;
    private NumberFormat format;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_selecionar_secao);
        secaoScrollView = findViewById(R.id.selecionarSecaoScrollView);
        secaoTable = findViewById(R.id.selecionarSecaoTable);
        secaoRadioGroup = findViewById(R.id.selecionarSecaoRadioGroup);
        secao1RadioButton = findViewById(R.id.selecionarSecao1RadioButton);
        secao2RadioButton = findViewById(R.id.selecionarSecao2RadioButton);
        secao3RadioButton = findViewById(R.id.selecionarSecao3RadioButton);
        secao4RadioButton = findViewById(R.id.selecionarSecao4RadioButton);
        aEditText = findViewById(R.id.selecionarSecaoAEditText);
        bEditText = findViewById(R.id.selecionarSecaoBEditText);
        hEditText = findViewById(R.id.selecionarSecaoHEditText);
        cEditText = findViewById(R.id.selecionarSecaoCEditText);
        dEditText = findViewById(R.id.selecionarSecaoDEditText);
        gamaEditText = findViewById(R.id.selecionarSecaoGamaEditText);
        fiEditText = findViewById(R.id.selecionarSecaoFiEditText);
        coesaoMaxEditText = findViewById(R.id.selecionarSecaoCoesaoMaxEditText);
        confirmarButton = findViewById(R.id.selecionarSecaoButton);

        cmin = new ArrayList<>();
        format = NumberFormat.getInstance(Locale.getDefault());
        Intent it = getIntent();
        if(it!=null){
            Bundle params = it.getExtras();
            if(params!=null){
                titulo = params.getString("titulo");
                destinoSimulacao = params.getInt("destino");
                posModulo = params.getInt("posModulo");
                posCapitulo = params.getInt("posCapitulo");
                unidades = params.getStringArrayList("unidades");
                ArrayList<String> ccn = new ArrayList<String>(params.getStringArrayList("cmin_ccn"));
                ArrayList<String> cce = new ArrayList<String>(params.getStringArrayList("cmin_cce"));
                ArrayList<String> ccl = new ArrayList<String>(params.getStringArrayList("cmin_ccl"));
                ArrayList<String> ccc = new ArrayList<String>(params.getStringArrayList("cmin_ccc"));
                cmin.add(ccn);
                cmin.add(cce);
                cmin.add(ccl);
                cmin.add(ccc);
            }
        }
        if(destinoSimulacao == 5 || destinoSimulacao == 6){
            fiEditText.setEnabled(true);
            coesaoMaxEditText.setEnabled(true);
        }
        listeners();
    }

    private void listeners() {
        secaoRadioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (secao1RadioButton.isChecked()) {
                    cEditText.setEnabled(false);
                    dEditText.setEnabled(false);
                    cEditText.setText("");
                    dEditText.setText("");
                    c = 0;
                    d = 0;
                }
                if (secao2RadioButton.isChecked()) {
                    cEditText.setEnabled(false);
                    dEditText.setEnabled(true);
                    cEditText.setText("");
                    c = 0;
                }
                if (secao3RadioButton.isChecked()) {
                    cEditText.setEnabled(true);
                    dEditText.setEnabled(false);
                    dEditText.setText("");
                    d = 0;
                }
                if (secao4RadioButton.isChecked()) {
                    cEditText.setEnabled(true);
                    dEditText.setEnabled(true);
                }
                secaoTable.setVisibility(View.VISIBLE);
                setMargins(secaoScrollView, getResources().getDimensionPixelSize(R.dimen.margem), getResources().getDimensionPixelSize(R.dimen.espacamento),
                        getResources().getDimensionPixelSize(R.dimen.margem), getResources().getDimensionPixelSize(R.dimen.altura_tabela_selecionar_secao));
            }
        });

        aEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.selecionar_secao_a_hint), unidades.get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        bEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.selecionar_secao_b_hint), unidades.get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        hEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.selecionar_secao_h_hint), unidades.get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        cEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.selecionar_secao_c_hint), unidades.get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        dEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.selecionar_secao_d_hint), unidades.get(0));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        gamaEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.selecionar_secao_gama_hint), unidades.get(1));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        fiEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_deslizamento_atrito_angulo_hint), unidades.get(5));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        coesaoMaxEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(hasFocus){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.selecionar_secao_aviso_unidade),
                            v.getContext().getResources().getString(R.string.simular_deslizamento_coesao_max_hint), unidades.get(6));
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });

        confirmarButton.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view){
                try{
                    a = format.parse(aEditText.getText().toString());
                    b = format.parse(bEditText.getText().toString());
                    h = format.parse(hEditText.getText().toString());
                    gama = format.parse(gamaEditText.getText().toString());
                    if(destinoSimulacao == 5 || destinoSimulacao == 6){
                        fi = format.parse(fiEditText.getText().toString());
                        coesaomax = format.parse(coesaoMaxEditText.getText().toString());
                    }
                    if (secao3RadioButton.isChecked() || secao4RadioButton.isChecked()) {
                        c = format.parse(cEditText.getText().toString());
                    }
                    if (secao2RadioButton.isChecked() || secao4RadioButton.isChecked()) {
                        d = format.parse(dEditText.getText().toString());
                    }
                    if(a.doubleValue() < 0){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_negativo),
                                view.getContext().getResources().getString(R.string.selecionar_secao_a_hint));
                    }else if(b.doubleValue() < format.parse(view.getContext().getResources().getString(R.string.selecionar_secao_b_min)).doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_invalido),
                                view.getContext().getResources().getString(R.string.selecionar_secao_b_hint),
                                format.parse(view.getContext().getResources().getString(R.string.selecionar_secao_b_min)).doubleValue(),
                                unidades.get(0));
                    }else if((secao3RadioButton.isChecked() || secao4RadioButton.isChecked()) && c.doubleValue() < 0){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_negativo),
                                view.getContext().getResources().getString(R.string.selecionar_secao_c_hint));
                    }else if((secao2RadioButton.isChecked() || secao4RadioButton.isChecked()) && d.doubleValue() < 0){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_negativo),
                                view.getContext().getResources().getString(R.string.selecionar_secao_d_hint));
                    }else if(h.doubleValue() < format.parse(view.getContext().getResources().getString(R.string.selecionar_secao_h_min)).doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_invalido),
                                view.getContext().getResources().getString(R.string.selecionar_secao_h_hint),
                                format.parse(view.getContext().getResources().getString(R.string.selecionar_secao_h_min)).doubleValue(),
                                unidades.get(0));
                    }else if(gama.doubleValue() < format.parse(view.getContext().getResources().getString(R.string.selecionar_secao_gama_min)).doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_invalido),
                                view.getContext().getResources().getString(R.string.selecionar_secao_gama_hint),
                                format.parse(view.getContext().getResources().getString(R.string.selecionar_secao_gama_min)).doubleValue(),
                                unidades.get(1));
                    }else if(b.doubleValue() < a.doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro),
                                view.getContext().getResources().getString(R.string.selecionar_secao_b_hint), view.getContext().getResources().getString(R.string.selecionar_secao_a_hint));
                    }else if(h.doubleValue() < c.doubleValue()){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro),
                                view.getContext().getResources().getString(R.string.selecionar_secao_h_hint), view.getContext().getResources().getString(R.string.selecionar_secao_c_hint));
                    }else if((destinoSimulacao == 5 || destinoSimulacao == 6) && fi.doubleValue() <= 0){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_zerado),
                                view.getContext().getResources().getString(R.string.simular_deslizamento_atrito_angulo_hint));
                    }else if((destinoSimulacao == 5 || destinoSimulacao == 6) && coesaomax.doubleValue() <= 0){
                        feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.selecionar_secao_feedback_parametro_zerado),
                                view.getContext().getResources().getString(R.string.simular_deslizamento_coesao_max_hint));
                    }else{
                        feedback = "";
                        Intent it = new Intent();
                        Bundle params = new Bundle();
                        params.putInt("destino", destinoSimulacao);
                        if (secao1RadioButton.isChecked()) {
                            Secao1 simulacao = new Secao1(posModulo, posCapitulo, titulo, a.doubleValue(), b.doubleValue(), h.doubleValue(), gama.doubleValue());
                            simulacao.setUnidades(unidades);
                            simulacao.obterTolerancia(view.getContext());
                            if(destinoSimulacao == 5 || destinoSimulacao == 6){simulacao.setFi(fi.doubleValue());simulacao.setCoesaomax(coesaomax.doubleValue());}
                            params.putParcelable("simulacao", simulacao);
                        }
                        if (secao2RadioButton.isChecked()) {
                            Secao2 simulacao = new Secao2(posModulo, posCapitulo, titulo, a.doubleValue(), b.doubleValue(), h.doubleValue(), gama.doubleValue(), d.doubleValue());
                            simulacao.setUnidades(unidades);
                            simulacao.obterTolerancia(view.getContext());
                            if(destinoSimulacao == 5 || destinoSimulacao == 6){simulacao.setFi(fi.doubleValue());simulacao.setCoesaomax(coesaomax.doubleValue());}
                            params.putParcelable("simulacao", simulacao);
                        }
                        if (secao3RadioButton.isChecked()) {
                            Secao3 simulacao = new Secao3(posModulo, posCapitulo, titulo, a.doubleValue(), b.doubleValue(), h.doubleValue(), gama.doubleValue(), c.doubleValue());
                            simulacao.setUnidades(unidades);
                            simulacao.obterTolerancia(view.getContext());
                            if(destinoSimulacao == 5 || destinoSimulacao == 6){simulacao.setFi(fi.doubleValue());simulacao.setCoesaomax(coesaomax.doubleValue());}
                            params.putParcelable("simulacao", simulacao);
                        }
                        if (secao4RadioButton.isChecked()) {
                            Secao4 simulacao = new Secao4(posModulo, posCapitulo, titulo, a.doubleValue(), b.doubleValue(), h.doubleValue(), gama.doubleValue(), c.doubleValue(), d.doubleValue());
                            simulacao.setUnidades(unidades);
                            simulacao.obterTolerancia(view.getContext());
                            if(destinoSimulacao == 5 || destinoSimulacao == 6){simulacao.setFi(fi.doubleValue());simulacao.setCoesaomax(coesaomax.doubleValue());}
                            params.putParcelable("simulacao", simulacao);
                        }
                        if(destinoSimulacao == 0){
                            it.setClass(view.getContext(), SimulacaoActivity.class); //SimulacaoActivity - CentroDeMassaFragment
                        }else{
                            it.setClass(view.getContext(), InformarNiveisActivity.class); //InformarNiveisActivity (destinos 1,3,4,5,6)
                            params.putStringArrayList("cmin_ccn", (ArrayList<String>) cmin.get(0));
                            params.putStringArrayList("cmin_cce", (ArrayList<String>) cmin.get(1));
                            params.putStringArrayList("cmin_ccl", (ArrayList<String>) cmin.get(2));
                            params.putStringArrayList("cmin_ccc", (ArrayList<String>) cmin.get(3));
                        }
                        it.putExtras(params);
                        view.getContext().startActivity(it);
                        //feedback = "A= " + a + unidades.get(0) + "; B= " + b + unidades.get(0) + "; H= " + h + unidades.get(0) + "; C= " + c + unidades.get(0) + "; D= " + d + unidades.get(0) + "; Gama= " + gama + unidades.get(1);
                    }
                }catch(Exception e){
                    feedback = String.format(Locale.getDefault(),view.getContext().getResources().getString(R.string.aviso_campos_nao_preenchidos));
                }

                if(!feedback.isEmpty()){
                    Toast.makeText(view.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });
    }

    private void setMargins (View view, int left, int top, int right, int bottom) {
        if (view.getLayoutParams() instanceof ViewGroup.MarginLayoutParams) {
            ViewGroup.MarginLayoutParams p = (ViewGroup.MarginLayoutParams) view.getLayoutParams();
            p.setMargins(left, top, right, bottom);
            view.requestLayout();
        }
    }

}