package com.example.dams;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.res.ResourcesCompat;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentTransaction;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;

import java.util.Locale;

public class SimulacaoActivity extends AppCompatActivity {

    private TextView tituloTextView;
    private ImageView simulacaoImageView;
    private EditText aEditText,bEditText,hEditText,cEditText,dEditText,gamacEditText,gamaaEditText,mEditText,jEditText, fiEditText, coesaomaxEditText;
    private Spinner ccSpinner;
    private int destinoSimulacao;
    private SimulacaoViewModel simulacaoViewModel;
    private Fragment simulationFragment, feedbackFragment;
    private FrameLayout feedbackFrame, simulationFrame;
    private String feedback;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_simulacao);
        tituloTextView = findViewById(R.id.simulacaoTituloTextView);
        simulacaoImageView = findViewById(R.id.simulacaoImageView);
        aEditText =findViewById(R.id.simulacaoAEditText);
        bEditText =findViewById(R.id.simulacaoBEditText);
        hEditText =findViewById(R.id.simulacaoHEditText);
        cEditText =findViewById(R.id.simulacaoCEditText);
        dEditText =findViewById(R.id.simulacaoDEditText);
        gamacEditText =findViewById(R.id.simulacaoGamaCEditText);
        gamaaEditText =findViewById(R.id.simulacaoGamaAEditText);
        mEditText =findViewById(R.id.simulacaoMEditText);
        jEditText =findViewById(R.id.simulacaoJEditText);
        fiEditText =findViewById(R.id.simulacaoFiEditText);
        coesaomaxEditText =findViewById(R.id.simulacaoCoesaoMaxEditText);
        ccSpinner =findViewById(R.id.simulacaoCCSpinner);
        feedbackFrame = findViewById(R.id.simulacaoFeedbackContainer);
        simulationFrame = findViewById(R.id.simulacaoTabelaContainer);
        simulacaoViewModel = new ViewModelProvider(this).get(SimulacaoViewModel.class);

        Intent it = getIntent();
        if(it!=null){
            Bundle params = it.getExtras();
            if(params!=null){
                simulacaoViewModel.setSimulacao((Simulacao) params.getParcelable("simulacao"));
                destinoSimulacao = params.getInt("destino");
            }
        }
        tituloTextView.setText(simulacaoViewModel.getSimulacao().getValue().getTitulo());
        listeners();
        setDestino();
        setVarTable();
    }

    public void setVarTable(){
        String formatSetEditText = getResources().getString(R.string.simular_parametros_set_text);
        aEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.selecionar_secao_a_hint), simulacaoViewModel.getSimulacao().getValue().getA(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0)));
        bEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.selecionar_secao_b_hint), simulacaoViewModel.getSimulacao().getValue().getB(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0)));
        hEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.selecionar_secao_h_hint), simulacaoViewModel.getSimulacao().getValue().getH(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0)));
        cEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.selecionar_secao_c_hint), simulacaoViewModel.getSimulacao().getValue().getC(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0)));
        dEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.selecionar_secao_d_hint), simulacaoViewModel.getSimulacao().getValue().getD(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0)));
        gamacEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.selecionar_secao_gama_hint), simulacaoViewModel.getSimulacao().getValue().getGamac(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(1)));
        gamaaEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.informar_niveis_gama_hint), simulacaoViewModel.getSimulacao().getValue().getGamaa(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(1)));
        mEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.informar_niveis_m_hint), simulacaoViewModel.getSimulacao().getValue().getM(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0)));
        jEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.informar_niveis_j_hint), simulacaoViewModel.getSimulacao().getValue().getJ(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(0)));
        fiEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.simular_deslizamento_atrito_angulo_hint), simulacaoViewModel.getSimulacao().getValue().getFi(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(5)));
        coesaomaxEditText.setText(String.format(Locale.getDefault(),formatSetEditText, getResources().getString(R.string.simular_deslizamento_coesao_max_hint), simulacaoViewModel.getSimulacao().getValue().getCoesaomax(), simulacaoViewModel.getSimulacao().getValue().getUnidades().get(6)));
        ccSpinner.setEnabled(false);
        ccSpinner.setSelection(simulacaoViewModel.getSimulacao().getValue().getCc());
        if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1){
            cEditText.setEnabled(false);
            dEditText.setEnabled(false);
        }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2){
            cEditText.setEnabled(false);
        }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
            dEditText.setEnabled(false);
        }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
            //mostra todos os campos geométricos
        }
    }

    public void showFeedbackFragment(){
        if(feedbackFrame.getVisibility() == View.INVISIBLE){
            feedbackFrame.setVisibility(View.VISIBLE);
            FragmentTransaction transaction = getSupportFragmentManager().beginTransaction(); //Gerencia fragmentos
            feedbackFragment = FeedbackFragment.newInstance(simulacaoViewModel.getSimulacao().getValue().getFeedback(),
                    simulacaoViewModel.getSimulacao().getValue().getFigmascote(),
                    simulacaoViewModel.getSimulacao().getValue().getAnimacao());
            transaction.replace(feedbackFrame.getId(), feedbackFragment);
            //transaction.addToBackStack(null);
            transaction.commit();
        }
    }

    public void listeners(){
        simulacaoViewModel.getSimulacao().observe(this, new Observer<Simulacao>() {
            @Override
            public void onChanged(Simulacao simulacao) {
                showFeedbackFragment();
            }
        });

        feedbackFrame.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                FragmentTransaction transaction = getSupportFragmentManager().beginTransaction(); //Gerencia fragmentos
                transaction.remove(feedbackFragment).commit();
                feedbackFrame.setVisibility(View.INVISIBLE);
                if(simulacaoViewModel.getSimulacao().getValue().isFim()){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simulacao_concluida), simulacaoViewModel.getSimulacao().getValue().getTitulo());
                    Intent it = new Intent(SimulacaoActivity.this, MainActivity.class);
                    Bundle params = new Bundle();
                    params.putBoolean("hasFeedback", true);
                    params.putString("feedback", feedback);
                    params.putInt("figmascote", R.drawable.mascote_5);
                    params.putInt("animacao", 0);
                    params.putBoolean("hasUpdate", true);
                    params.putInt("posModulo", simulacaoViewModel.getSimulacao().getValue().getPosModulo());
                    params.putInt("posCapitulo", simulacaoViewModel.getSimulacao().getValue().getPosCapitulo());
                    it.putExtras(params);
                    startActivity(it);
                }
            }
        });

    }

    private void setDestino() {
        FragmentTransaction transaction = getSupportFragmentManager().beginTransaction(); //Gerencia fragmentos
        switch (destinoSimulacao){
            case 0:{
                simulationFragment = CentroDeMassaFragment.newInstance();
                gamaaEditText.setEnabled(false);
                mEditText.setEnabled(false);
                jEditText.setEnabled(false);
                ccSpinner.setEnabled(false);
                simulacaoViewModel.getSimulacao().getValue().obterFeedbackCentroMassa(-1,-1,-1);
                if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao1,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao2,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao3,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao4,null)).into(simulacaoImageView);
                }
                break;
            }
            case 1:{
                simulationFragment = PressoesFragment.newInstance();
                ccSpinner.setEnabled(false);
                simulacaoViewModel.getSimulacao().getValue().obterFeedbackForcaPressao(-1,-1,false,-1,-1,false,-1,-1,false,-1,-1,false);
                if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao1_pressoes,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao2_pressoes,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao3_pressoes,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao4_pressoes,null)).into(simulacaoImageView);
                }
                break;
            }
            case 3:{
                simulationFragment = FlutuacaoFragment.newInstance();
                simulacaoViewModel.getSimulacao().getValue().obterFeedbackFlutuacao(-1,-1,false,-1);
                if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao1_flutuacao,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao2_flutuacao,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao3_flutuacao,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao4_flutuacao,null)).into(simulacaoImageView);
                }
                break;
            }
            case 4:{
                simulationFragment = TombamentoFragment.newInstance();
                simulacaoViewModel.getSimulacao().getValue().obterFeedbackTombamento(-1,-1,-1);
                if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao1_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao2_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao3_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao4_completo,null)).into(simulacaoImageView);
                }
                break;
            }
            case 5:{
                simulationFragment = DeslizamentoFragment.newInstance();
                simulacaoViewModel.getSimulacao().getValue().obterFeedbackDeslizamentoAtrito(-1,-1);
                if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao1_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao2_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao3_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao4_completo,null)).into(simulacaoImageView);
                }
                break;
            }
            case 6:{
                simulationFragment = TensoesFragment.newInstance();
                simulacaoViewModel.getSimulacao().getValue().obterFeedbackTensaoBase(-1,-1,-1);
                if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao1){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao1_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao2){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao2_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao3){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao3_completo,null)).into(simulacaoImageView);
                }else if(simulacaoViewModel.getSimulacao().getValue() instanceof Secao4){
                    Glide.with(this).load(ResourcesCompat.getDrawable(getResources(),R.drawable.secao4_completo,null)).into(simulacaoImageView);
                }
                break;
            }
        }
        transaction.replace(simulationFrame.getId(), simulationFragment);
        //transaction.addToBackStack(null);
        transaction.commit();
        simulacaoViewModel.setSimulacao(simulacaoViewModel.getSimulacao().getValue());
    }
}