package com.example.dams;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.res.Resources;
import android.content.res.TypedArray;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.GenericTypeIndicator;
import com.google.firebase.database.ValueEventListener;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Locale;

public class SimularCCActivity extends AppCompatActivity {

    private TextView tituloTextView, mTextView, jTextView, casoTextView;
    private RadioGroup mRadioGroup, jRadioGroup, casoRadioGroup;
    private RadioButton mOp1RadioButton, mOp2RadioButton, mOp3RadioButton, mOp4RadioButton,
            jOp1RadioButton, jOp2RadioButton, jOp3RadioButton, jOp4RadioButton,
            casoOp1RadioButton, casoOp2RadioButton, casoOp3RadioButton, casoOp4RadioButton;
    private ProgressBar simularCCProgressBar;
    private Button simularCCButton;
    private Simulacao simulacao;
    private String titulo, feedback, resposta;
    private int destinoSimulacao;
    private List<String> montante, jusante, casos;
    private List<List<String>> respostas, cmin;
    private List<List<Boolean>> flags;
    private int tentativas = 0, acertos = 0, indexMontante, indexJusante, indexCC, posModulo, posCapitulo;
    private boolean fim = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_simular_c_c);
        tituloTextView = findViewById(R.id.simularCCTituloTextView);
        mTextView = findViewById(R.id.simularCCMTextView);
        jTextView = findViewById(R.id.simularCCJTextView);
        casoTextView = findViewById(R.id.simularCCRTextView);
        mRadioGroup = findViewById(R.id.simularCCMRadioGroup);
        jRadioGroup = findViewById(R.id.simularCCJRadioGroup);
        casoRadioGroup = findViewById(R.id.simularCCRRadioGroup);
        mOp1RadioButton = findViewById(R.id.simularCCMOp1RadioButton);
        mOp2RadioButton = findViewById(R.id.simularCCMOp2RadioButton);
        mOp3RadioButton = findViewById(R.id.simularCCMOp3RadioButton);
        mOp4RadioButton = findViewById(R.id.simularCCMOp4RadioButton);
        jOp1RadioButton = findViewById(R.id.simularCCJOp1RadioButton);
        jOp2RadioButton = findViewById(R.id.simularCCJOp2RadioButton);
        jOp3RadioButton = findViewById(R.id.simularCCJOp3RadioButton);
        jOp4RadioButton = findViewById(R.id.simularCCJOp4RadioButton);
        casoOp1RadioButton = findViewById(R.id.simularCCROp1RadioButton);
        casoOp2RadioButton = findViewById(R.id.simularCCROp2RadioButton);
        casoOp3RadioButton = findViewById(R.id.simularCCROp3RadioButton);
        casoOp4RadioButton = findViewById(R.id.simularCCROp4RadioButton);
        simularCCProgressBar = findViewById(R.id.simularCCProgressBar);
        simularCCButton = findViewById(R.id.simularCCButton);

        montante = new ArrayList<>(Arrays.asList(getResources().getStringArray(R.array.nam_eletrobras)));
        jusante = new ArrayList<>(Arrays.asList(getResources().getStringArray(R.array.naj_eletrobras)));
        casos = new ArrayList<>(Arrays.asList(getResources().getStringArray(R.array.casos_eletrobras)));
        mTextView.setText(montante.get(0));
        jTextView.setText(jusante.get(0));
        casoTextView.setText(getResources().getString(R.string.simular_cc_hint));
        mOp1RadioButton.setText(montante.get(1));
        mOp2RadioButton.setText(montante.get(2));
        mOp3RadioButton.setText(montante.get(3));
        mOp4RadioButton.setText(montante.get(4));
        jOp1RadioButton.setText(jusante.get(1));
        jOp2RadioButton.setText(jusante.get(2));
        jOp3RadioButton.setText(jusante.get(3));
        jOp4RadioButton.setText(jusante.get(4));
        casoOp1RadioButton.setText(casos.get(0));
        casoOp2RadioButton.setText(casos.get(1));
        casoOp3RadioButton.setText(casos.get(2));
        casoOp4RadioButton.setText(casos.get(3));

        respostas = new ArrayList<>();
        flags = new ArrayList<>();
        TypedArray ta = getResources().obtainTypedArray(R.array.casos_eletrobras_respostas_ids);
        for(int i=0; i<ta.length(); i++){
            int id = ta.getResourceId(i, 0);
            if (id > 0) {
                List<Boolean> auxFlags = new ArrayList<>();
                List<String> auxRespostas = new ArrayList<>(Arrays.asList(getResources().getStringArray(id)));
                respostas.add(auxRespostas);
                for(int j=0; j<respostas.get(i).size();j++){
                    auxFlags.add(false);
                }
                flags.add(auxFlags);
            }
        }
        ta.recycle();

        Intent it = getIntent();
        Bundle params = new Bundle();
        if(it!=null){
            params = it.getExtras();
            if(params!=null){
                destinoSimulacao = params.getInt("destino");
                posModulo = params.getInt("posModulo");
                posCapitulo = params.getInt("posCapitulo");
            }
        }

        if(destinoSimulacao == 2){
            titulo = params.getString("titulo");
            simularCCButton.setText(R.string.simular_cc_responder);
            listenerSimularCC();
        }else{
            simulacao = params.getParcelable("simulacao");
            titulo = simulacao.getTitulo();
            cmin = new ArrayList<>();
            ArrayList<String> ccn = new ArrayList<String>(params.getStringArrayList("cmin_ccn"));
            ArrayList<String> cce = new ArrayList<String>(params.getStringArrayList("cmin_cce"));
            ArrayList<String> ccl = new ArrayList<String>(params.getStringArrayList("cmin_ccl"));
            ArrayList<String> ccc = new ArrayList<String>(params.getStringArrayList("cmin_ccc"));
            cmin.add(ccn);
            cmin.add(cce);
            cmin.add(ccl);
            cmin.add(ccc);
            setCasosEnabled(false);
            simularCCProgressBar.setVisibility(View.INVISIBLE);
            simularCCButton.setText(R.string.simular_cc_confirmar);
            listenersOtherSimulations();
        }
        tituloTextView.setText(titulo);

    }

    private void listenersOtherSimulations(){
        mRadioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if(mRadioGroup.getCheckedRadioButtonId() != -1 && jRadioGroup.getCheckedRadioButtonId() != -1){
                    indexMontante = getIndexMontante(mRadioGroup.getCheckedRadioButtonId());
                    indexJusante = getIndexJusante(jRadioGroup.getCheckedRadioButtonId());
                    resposta = respostas.get(indexMontante).get(indexJusante);
                    if(resposta.equals(casos.get(0))){
                        casoOp1RadioButton.setChecked(true);
                    }else if(resposta.equals(casos.get(1))){
                        casoOp2RadioButton.setChecked(true);
                    }else if(resposta.equals(casos.get(2))){
                        casoOp3RadioButton.setChecked(true);
                    }else if(resposta.equals(casos.get(3))){
                        casoOp4RadioButton.setChecked(true);
                    }
                }
            }
        });

        jRadioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if(mRadioGroup.getCheckedRadioButtonId() != -1 && jRadioGroup.getCheckedRadioButtonId() != -1){
                    indexMontante = getIndexMontante(mRadioGroup.getCheckedRadioButtonId());
                    indexJusante = getIndexJusante(jRadioGroup.getCheckedRadioButtonId());
                    resposta = respostas.get(indexMontante).get(indexJusante);
                    if(resposta.equals(casos.get(0))){
                        casoOp1RadioButton.setChecked(true);
                    }else if(resposta.equals(casos.get(1))){
                        casoOp2RadioButton.setChecked(true);
                    }else if(resposta.equals(casos.get(2))){
                        casoOp3RadioButton.setChecked(true);
                    }else if(resposta.equals(casos.get(3))){
                        casoOp4RadioButton.setChecked(true);
                    }
                }
            }
        });

        simularCCButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(mRadioGroup.getCheckedRadioButtonId() == -1){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_alternativa_nao_selecionada), montante.get(0));
                }else if(jRadioGroup.getCheckedRadioButtonId() == -1){
                    feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_alternativa_nao_selecionada), jusante.get(0));
                }else {
                    feedback = "";
                    indexMontante = getIndexMontante(mRadioGroup.getCheckedRadioButtonId());
                    indexJusante = getIndexJusante(jRadioGroup.getCheckedRadioButtonId());
                    resposta = respostas.get(indexMontante).get(indexJusante);
                    if(resposta.equals(casos.get(0))){
                        //feedback = String.format("%s %s", casoTextView.getText().toString(), casos.get(0));
                        simulacao.setCc(0);
                    }else if(resposta.equals(casos.get(1))){
                        //feedback = String.format("%s %s", casoTextView.getText().toString(), casos.get(1));
                        simulacao.setCc(1);
                    }else if(resposta.equals(casos.get(2))){
                        //feedback = String.format("%s %s", casoTextView.getText().toString(), casos.get(2));
                        simulacao.setCc(2);
                    }else if(resposta.equals(casos.get(3))){
                        //feedback = String.format("%s %s", casoTextView.getText().toString(), casos.get(3));
                        simulacao.setCc(3);
                    }
                    simulacao.setCmin(cmin.get(simulacao.getCc()));
                    Intent it = new Intent(v.getContext(), SimulacaoActivity.class);
                    Bundle params = new Bundle();
                    params.putInt("destino", destinoSimulacao);

                    if(simulacao instanceof Secao1){
                        params.putParcelable("simulacao", (Secao1)simulacao);
                    }else if(simulacao instanceof Secao2){
                        params.putParcelable("simulacao", (Secao2)simulacao);
                    }else if(simulacao instanceof Secao3){
                        params.putParcelable("simulacao", (Secao3)simulacao);
                    }else if(simulacao instanceof Secao4){
                        params.putParcelable("simulacao", (Secao4)simulacao);
                    }
                    it.putExtras(params);
                    v.getContext().startActivity(it);
                }
                if(!feedback.isEmpty()){
                    Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                }
            }
        });
    }

    private void listenerSimularCC(){

        simularCCButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(fim){
                    if(acertos >= v.getContext().getResources().getInteger(R.integer.simular_cc_min_acertos)){
                        feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_concluido), acertos, tentativas, titulo);
                        Intent it = new Intent(SimularCCActivity.this, MainActivity.class);
                        Bundle params = new Bundle();
                        params.putBoolean("hasFeedback", true);
                        params.putString("feedback", feedback + " Hora de explodir algumas coisas em nossa obra. Esta é minha parte favorita!");
                        params.putInt("figmascote", R.drawable.mascote_5);
                        params.putInt("animacao", 0);
                        params.putBoolean("hasUpdate", true);
                        params.putInt("posModulo", posModulo);
                        params.putInt("posCapitulo", posCapitulo);
                        it.putExtras(params);
                        acertos = 0;
                        tentativas = 0;
                        startActivity(it);
                    }else{
                        feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_nao_concluido), v.getContext().getResources().getInteger(R.integer.simular_cc_min_acertos));
                        Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                        simularCCButton.setText(v.getContext().getResources().getString(R.string.simular_cc_responder));
                        acertos = 0;
                        tentativas = 0;
                    }
                    simularCCProgressBar.setProgress(0);
                    fim = false;
                    setMontanteEnabled(true);
                    setJusanteEnabled(true);
                    setCasosEnabled(true);
                    for(int i=0; i<flags.size(); i++){
                        for(int j=0; j<flags.get(i).size(); j++){
                            flags.get(i).set(j, false);
                        }
                    }
                }else{
                    if(mRadioGroup.getCheckedRadioButtonId() == -1){
                        feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_alternativa_nao_selecionada), montante.get(0));
                    }else if(jRadioGroup.getCheckedRadioButtonId() == -1){
                        feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_alternativa_nao_selecionada), jusante.get(0));
                    }else if(casoRadioGroup.getCheckedRadioButtonId() == -1){
                        feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_alternativa_nao_selecionada), casoTextView.getText().toString());
                    }else{
                        indexMontante = getIndexMontante(mRadioGroup.getCheckedRadioButtonId());
                        indexJusante = getIndexJusante(jRadioGroup.getCheckedRadioButtonId());
                        indexCC = getIndexCC(casoRadioGroup.getCheckedRadioButtonId());
                        if(flags.get(indexMontante).get(indexJusante)){
                            feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_comb_repetida));
                        }else{
                            tentativas++;
                            simularCCProgressBar.setProgress(tentativas);
                            flags.get(indexMontante).set(indexJusante, true);
                            resposta = respostas.get(indexMontante).get(indexJusante);
                            if(resposta.equals(casos.get(indexCC))){
                                acertos++;
                                feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_comb_correta));
                            }else{
                                feedback = String.format(Locale.getDefault(),v.getContext().getResources().getString(R.string.simular_cc_comb_incorreta), casos.get(indexCC));
                            }
                            if(tentativas == v.getContext().getResources().getInteger(R.integer.simular_cc_num_tentativas)){
                                fim = true;
                                setMontanteEnabled(false);
                                setJusanteEnabled(false);
                                setCasosEnabled(false);
                                simularCCButton.setText(v.getContext().getResources().getString(R.string.simular_cc_concluir));
                            }
                        }
                    }
                    if(!feedback.isEmpty()){
                        Toast.makeText(v.getContext(), feedback, Toast.LENGTH_LONG).show();
                    }
                }
            }
        });
    }

    private int getIndexMontante(int id){
        int index = 0;
        switch (id){
            case R.id.simularCCMOp1RadioButton:{
                index = 0;
                break;
            }
            case R.id.simularCCMOp2RadioButton:{
                index = 1;
                break;
            }
            case R.id.simularCCMOp3RadioButton:{
                index = 2;
                break;
            }
            case R.id.simularCCMOp4RadioButton:{
                index = 3;
                break;
            }
        }
        return index;
    }

    private int getIndexJusante(int id){
        int index = 0;
        switch (id){
            case R.id.simularCCJOp1RadioButton:{
                index = 0;
                break;
            }
            case R.id.simularCCJOp2RadioButton:{
                index = 1;
                break;
            }
            case R.id.simularCCJOp3RadioButton:{
                index = 2;
                break;
            }
            case R.id.simularCCJOp4RadioButton:{
                index = 3;
                break;
            }
        }
        return index;
    }

    private int getIndexCC(int id){
        int index = 0;
        switch (id){
            case R.id.simularCCROp1RadioButton:{
                index = 0;
                break;
            }
            case R.id.simularCCROp2RadioButton:{
                index = 1;
                break;
            }
            case R.id.simularCCROp3RadioButton:{
                index = 2;
                break;
            }
            case R.id.simularCCROp4RadioButton:{
                index = 3;
                break;
            }
        }
        return index;
    }

    private void setMontanteEnabled(boolean ativo){
        if(ativo){
            mOp1RadioButton.setEnabled(true);
            mOp2RadioButton.setEnabled(true);
            mOp3RadioButton.setEnabled(true);
            mOp4RadioButton.setEnabled(true);
        }else{
            mRadioGroup.clearCheck();
            mOp1RadioButton.setEnabled(false);
            mOp2RadioButton.setEnabled(false);
            mOp3RadioButton.setEnabled(false);
            mOp4RadioButton.setEnabled(false);
        }
    }

    private void setJusanteEnabled(boolean ativo){
        if(ativo){
            jOp1RadioButton.setEnabled(true);
            jOp2RadioButton.setEnabled(true);
            jOp3RadioButton.setEnabled(true);
            jOp4RadioButton.setEnabled(true);
        }else{
            jRadioGroup.clearCheck();
            jOp1RadioButton.setEnabled(false);
            jOp2RadioButton.setEnabled(false);
            jOp3RadioButton.setEnabled(false);
            jOp4RadioButton.setEnabled(false);
        }
    }

    private void setCasosEnabled(boolean ativo){
        if(ativo){
            casoOp1RadioButton.setEnabled(true);
            casoOp2RadioButton.setEnabled(true);
            casoOp3RadioButton.setEnabled(true);
            casoOp4RadioButton.setEnabled(true);
        }else{
            casoRadioGroup.clearCheck();
            casoOp1RadioButton.setEnabled(false);
            casoOp2RadioButton.setEnabled(false);
            casoOp3RadioButton.setEnabled(false);
            casoOp4RadioButton.setEnabled(false);
        }
    }
}