package com.example.dams;

import android.content.Intent;
import android.content.res.Configuration;
import android.os.Debug;
import android.os.Handler;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;

import androidx.appcompat.app.AppCompatActivity;

import com.bumptech.glide.Glide;

import java.util.Locale;

public class SplashScreenActivity extends AppCompatActivity {

    private static final String TAG = "HEAP_SIZE_USED";
    private ImageView btfLogo;
    private Handler handler;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splash_screen);
        btfLogo = findViewById(R.id.btfLogoImageView);
        Glide.with(this).load(R.drawable.btf_logo).into(btfLogo);
        //displayMemoryUsage("Gravity Dams");
    }

    @Override
    protected void onResume() {
        super.onResume();
        Locale locale = new Locale("pt", "BR");
        Locale.setDefault(locale);
        Configuration config = getBaseContext().getResources().getConfiguration();
        config.locale = locale;
        getBaseContext().getResources().updateConfiguration(config,getBaseContext().getResources().getDisplayMetrics());
        Animation anim = AnimationUtils.loadAnimation(this, R.anim.btf_logo);
        btfLogo.startAnimation(anim);
        handler = new Handler();
        handler.postDelayed(new Runnable() {
            @Override
            public void run() {
                iniciar();
            }
        }, getResources().getInteger(R.integer.btfLogo_animDuration));
    }

    private void iniciar() {
        Intent intent = new Intent(SplashScreenActivity.this, IniciarActivity.class);
        intent.setFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
        startActivity(intent);
        SplashScreenActivity.this.finish();
    }

    protected void displayMemoryUsage(String message) {
        int usedKBytes = (int) (Debug.getNativeHeapAllocatedSize() / 1024L);
        String usedMegsString = String.format("%s - usedMemory = Memory Used: %d KB", message, usedKBytes);
        Log.d(TAG, usedMegsString);
    }
}
    /*@Override
    protected void onDestroy() {
        super.onDestroy();
        unbindDrawables(findViewById(R.id.splashLayout));
        System.gc();
    }

    private void unbindDrawables(View view) {
        if (view.getBackground() != null) {
            view.getBackground().setCallback(null);
        }
        if (view instanceof ViewGroup) {
            for (int i = 0; i < ((ViewGroup) view).getChildCount(); i++) {
                unbindDrawables(((ViewGroup) view).getChildAt(i));
            }
            ((ViewGroup) view).removeAllViews();
        }
    }*/