package com.example.dams;

import android.content.Context;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class Usuario {
    private int loginMethod;
    private String username;
    private List<List<Integer>> progressoCurso, progressoDesafios;
    private List<String> unidades;
    private List<List<String>> cmin;

    public Usuario() {
    }

    public Usuario(int loginMethod, String username) {
        this.loginMethod = loginMethod;
        this.username = username;
    }

    public Usuario(int loginMethod, String username, List<List<Integer>> progressoCurso, List<List<Integer>> progressoDesafios, List<String> unidades, List<List<String>> cmin) {
        this.loginMethod = loginMethod;
        this.username = username;
        this.progressoCurso = progressoCurso;
        this.progressoDesafios = progressoDesafios;
        this.unidades = unidades;
        this.cmin = cmin;
    }

    public int getLoginMethod() {
        return loginMethod;
    }

    public void setLoginMethod(int loginMethod) {
        this.loginMethod = loginMethod;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public List<List<Integer>> getProgressoCurso() {
        return progressoCurso;
    }

    public void setProgressoCurso(List<List<Integer>> progressoCurso) {
        this.progressoCurso = progressoCurso;
    }

    public List<List<Integer>> getProgressoDesafios() {
        return progressoDesafios;
    }

    public void setProgressoDesafios(List<List<Integer>> progressoDesafios) {
        this.progressoDesafios = progressoDesafios;
    }

    public List<String> getUnidades() {
        return unidades;
    }

    public void setUnidades(List<String> unidades) {
        this.unidades = unidades;
    }

    public List<List<String>> getCmin() {
        return cmin;
    }

    public void setCmin(List<List<String>> cmin) {
        this.cmin = cmin;
    }

    public void setParametrosPadrao(Context context){
        setProgressoCursoPadrao(context);
        setProgressoDesafiosPadrao(context);
        setCMINPadrao(context);
        setUnidadesPadrao(context);
    }

    public void setProgressoCursoPadrao(Context context) {
        this.progressoCurso  = new ArrayList<>();
        List<Integer> aux0 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo0_capitulos)).size(), 0));
        List<Integer> aux1 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo1_capitulos)).size(), 0));
        List<Integer> aux2 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo2_capitulos)).size(), 0));
        List<Integer> aux3 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo3_capitulos)).size(), 0));
        List<Integer> aux4 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo4_capitulos)).size(), 0));
        List<Integer> aux5 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo5_capitulos)).size(), 0));
        List<Integer> aux6 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo6_capitulos)).size(), 0));
        List<Integer> aux_capitulos = new ArrayList<>();
        this.progressoCurso.add(aux0);
        this.progressoCurso.add(aux1);
        this.progressoCurso.add(aux2);
        this.progressoCurso.add(aux3);
        this.progressoCurso.add(aux4);
        this.progressoCurso.add(aux5);
        this.progressoCurso.add(aux6);
    }

    public void setProgressoDesafiosPadrao(Context context) {
        this.progressoDesafios = new ArrayList<>();
        List<Integer> aux0 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio0)).size(), 0));
        List<Integer> aux1 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio1)).size(), 0));
        List<Integer> aux2 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio2)).size(), 0));
        List<Integer> aux3 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio3)).size(), 0));
        List<Integer> aux4 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio4)).size(), 0));
        this.progressoDesafios.add(aux0);
        this.progressoDesafios.add(aux1);
        this.progressoDesafios.add(aux2);
        this.progressoDesafios.add(aux3);
        this.progressoDesafios.add(aux4);
    }

    public void setCMINPadrao(Context context) { //Implementar em CasoCarregamentoActivity
        this.cmin = new ArrayList<List<String>>();
        List<String> aux0 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccn_eletrobras)));
        List<String> aux1 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.cce_eletrobras)));
        List<String> aux2 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccl_eletrobras)));
        List<String> aux3 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccc_eletrobras)));
        this.cmin.add(aux0);
        this.cmin.add(aux1);
        this.cmin.add(aux2);
        this.cmin.add(aux3);
    }

    public void setUnidadesPadrao(Context context) {
        this.unidades = new ArrayList<String>();
        this.unidades.addAll(Arrays.asList(context.getResources().getStringArray(R.array.simulacao_unidades_SI)));
    }

    public List<List<Integer>> obterProgressoCursoPadrao(Context context) {
        List<List<Integer>> progressoCurso  = new ArrayList<>();
        List<Integer> aux0 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo0_capitulos)).size(), 0));
        List<Integer> aux1 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo1_capitulos)).size(), 0));
        List<Integer> aux2 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo2_capitulos)).size(), 0));
        List<Integer> aux3 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo3_capitulos)).size(), 0));
        List<Integer> aux4 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo4_capitulos)).size(), 0));
        List<Integer> aux5 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo5_capitulos)).size(), 0));
        List<Integer> aux6 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.modulo6_capitulos)).size(), 0));
        List<Integer> aux_capitulos = new ArrayList<>();
        progressoCurso.add(aux0);
        progressoCurso.add(aux1);
        progressoCurso.add(aux2);
        progressoCurso.add(aux3);
        progressoCurso.add(aux4);
        progressoCurso.add(aux5);
        progressoCurso.add(aux6);
        return progressoCurso;
    }

    public List<List<Integer>> obterProgressoDesafiosPadrao(Context context) {
        List<List<Integer>> progressoDesafios = new ArrayList<>();
        List<Integer> aux0 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio0)).size(), 0));
        List<Integer> aux1 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio1)).size(), 0));
        List<Integer> aux2 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio2)).size(), 0));
        List<Integer> aux3 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio3)).size(), 0));
        List<Integer> aux4 = new ArrayList<Integer>(Collections.nCopies(Arrays.asList(context.getResources().getStringArray(R.array.desafio4)).size(), 0));
        progressoDesafios.add(aux0);
        progressoDesafios.add(aux1);
        progressoDesafios.add(aux2);
        progressoDesafios.add(aux3);
        progressoDesafios.add(aux4);
        return progressoDesafios;
    }

    public List<List<String>> obterCMINPadrao(Context context) { //Implementar em CasoCarregamentoActivity
        List<List<String>> cmin = new ArrayList<List<String>>();
        List<String> aux0 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccn_eletrobras)));
        List<String> aux1 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.cce_eletrobras)));
        List<String> aux2 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccl_eletrobras)));
        List<String> aux3 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccc_eletrobras)));
        cmin.add(aux0);
        cmin.add(aux1);
        cmin.add(aux2);
        cmin.add(aux3);
        return cmin;
    }

    public List<List<String>> obterCMINMax(Context context) { //Implementar em CasoCarregamentoActivity
        List<List<String>> cminMax = new ArrayList<List<String>>();
        List<String> aux0 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccn_parametros_maximos)));
        List<String> aux1 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.cce_parametros_maximos)));
        List<String> aux2 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccl_parametros_maximos)));
        List<String> aux3 = new ArrayList<String>(Arrays.asList(context.getResources().getStringArray(R.array.ccc_parametros_maximos)));
        cminMax.add(aux0);
        cminMax.add(aux1);
        cminMax.add(aux2);
        cminMax.add(aux3);
        return cminMax;
    }

    public List<String> obterUnidadesPadrao(Context context) {
        List<String> unidades = new ArrayList<String>();
        unidades.addAll(Arrays.asList(context.getResources().getStringArray(R.array.simulacao_unidades_SI)));
        return unidades;
    }
}
